function updateDomBgColor(someSong) {
    //console.log(someSong);
    if (activeSongId >= 0) {
        var prevActiveSongDom = document.getElementById("rowID"+activeSongId);
        prevActiveSongDom.style.background = "";
    }
    activeSongId = someSong.id; // update id
    var newActiveSongDom = document.getElementById("rowID" + activeSongId);
    newActiveSongDom.style.background = "rgb(0,180,0)";
}

const AUDIBLE=1;
const MUTED=0;
v1state = AUDIBLE;
v2state = AUDIBLE;
v3state = AUDIBLE;
v4state = AUDIBLE;

/*********************************************************************************************************************************/
/** scriptprocessor_player *******************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/



/**
 * Generic ScriptProcessor based WebAudio player.
 * <p>AudioBackendAdapterBase: an abstract base class for specific backend (i.e. 'sample data producer') integration.
 *
 *	version 1.03e+ (with WASM support, cached filename translation & track switch bugfix, "internal filename"
 *				mapping, getVolume, setPanning, AudioContext get/resume, AbstractTicker revisited, bugfix for
 *               duplicate events, improved "play after user gesture" support + doubled sample buffer size)
 *
 * 	Copyright (C) 2018 Juergen Wothke
 *
 * Terms of Use: This software is licensed under a CC BY-NC-SA
 * (http://creativecommons.org/licenses/by-nc-sa/4.0/).
 */
var fetchSamples = function (e) {
    window.player.genSamples.bind(window.player)(e);
},
    calcTick = function (e) {
        window.player.tick.bind(window.player)(e);
    },
    setGlobalWebAudioCtx = function () {
        if (void 0 === window._gPlayerAudioCtx) {
            var t = "Web Audio API is not supported in this browser";
            try {
                "AudioContext" in window ? (window._gPlayerAudioCtx = new AudioContext()) : "webkitAudioContext" in window ? (window._gPlayerAudioCtx = new webkitAudioContext()) : alert(t + e);
            } catch (e) {
                alert(t + e);
            }
        }
        try {
            "suspended" === window._gPlayerAudioCtx.state && "ontouchstart" in window && window._gPlayerAudioCtx.resume();
        } catch (e) { }
    };
function surrogateCtor() { }
function extend(e, t, i) {
    for (var a in ((surrogateCtor.prototype = e.prototype), (t.prototype = new surrogateCtor()), ((t.prototype.constructor = t).base = e), i)) t.prototype[a] = i[a];
    return t;
}
(AbstractTicker = function () { }),
    (AbstractTicker.prototype = {
        init: function (e, t) { },
        start: function () { },
        computeAudioSamplesNotify: function () { },
        resampleData: function (e, t, i, a) { },
        copyTickerData: function (e, t) { },
        calcTickData: function (e, t) { }
    });
var SAMPLES_PER_BUFFER = 16384;
(AudioBackendAdapterBase = function (e, t) {
    (this._resampleBuffer = new Float32Array()),
        (this._channels = e),
        (this._bytesPerSample = t),
        (this._sampleRate = 44100),
        (this._inputSampleRate = 44100),
        this._observer,
        (this._manualSetupComplete = !0);
}),
    (AudioBackendAdapterBase.prototype = {
        computeAudioSamples: function () {
            this.error("computeAudioSamples");
        },
        loadMusicData: function (e, t, i, a, r) {
            this.error("loadMusicData");
        },
        evalTrackOptions: function (e) {
            this.error("evalTrackOptions");
        },
        updateSongInfo: function (e, t) {
            this.error("updateSongInfo");
        },
        getSongInfoMeta: function () {
            this.error("getSongInfoMeta");
        },
        getAudioBuffer: function () {
            this.error("getAudioBuffer");
        },
        getAudioBufferLength: function () {
            this.error("getAudioBufferLength");
        },
        readFloatSample: function (e, t) {
            this.error("readFloatSample");
        },
        applyPanning: function (e, t, i) {
            this.error("applyPanning");
        },
        getBytesPerSample: function () {
            return this._bytesPerSample;
        },
        getChannels: function () {
            return this._channels;
        },
        isAdapterReady: function () {
            return !0;
        },
        mapInternalFilename: function (e, t, i) {
            return (e || t) + i;
        },
        mapUrl: function (e) {
            return e;
        },
        uploadFile: function (e, t) {
            return 0;
        },
        isManualSetupComplete: function () {
            return this._manualSetupComplete;
        },
        teardown: function () {
            this.error("teardown");
        },
        getMaxPlaybackPosition: function () {
            return 0;
        },
        getPlaybackPosition: function () {
            return 0;
        },
        seekPlaybackPosition: function (e) {
            return -1;
        },
        getPathAndFilename: function (e) {
            this.error("getPathAndFilename");
        },
        registerFileData: function (e, t) {
            this.error("registerFileData");
        },
        mapBackendFilename: function (e) {
            return e;
        },
        mapCacheFileName: function (e) {
            return e;
        },
        handleBackendSongAttributes: function (e, t) {
            this.error("handleBackendSongAttributes");
        },
        mapUri2Fs: function (e) {
            var t = e.replace(/\/\//, "ýý");
            return (t = (t = (t = (t = (t = (t = (t = t
                .replace(/\?/, "ÿ"))
                .replace(/:/, "þ"))
                .replace(/\*/, "ü"))
                .replace(/"/, "û"))
                .replace(/</, "ù"))
                .replace(/>/, "ø"))
                .replace(/\|/, "÷"));
        },
        mapFs2Uri: function (e) {
            var t = e.replace(/ýý/, "//");
            return (t = (t = (t = (t = (t = (t = (t = t
                .replace(/ÿ/, "?"))
                .replace(/þ/, ":"))
                .replace(/ü/, "*"))
                .replace(/û/, '"'))
                .replace(/ù/, "<"))
                .replace(/ø/, ">"))
                .replace(/÷/, "|"));
        },
        setObserver: function (e) {
            this._observer = e;
        },
        notifyAdapterReady: function () {
            void 0 !== this._observer && this._observer.notify();
        },
        error: function (e) {
            alert("fatal error: abstract method '" + e + "' must be defined");
        },
        resetSampleRate: function (e, t) {
            0 < e && (this._sampleRate = e), 0 < t && (this._inputSampleRate = t);
            var i = Math.round((SAMPLES_PER_BUFFER * this._sampleRate) / this._inputSampleRate) * this.getChannels();
            i > this._resampleBuffer.length && (this._resampleBuffer = this.allocResampleBuffer(i));
        },
        allocResampleBuffer: function (e) {
            return new Float32Array(e);
        },
        getCopiedAudio: function (e, t, i, a) {
            var r;
            for (r = 0; r < t * this._channels; r++) a[r] = i(e, r);
            return t;
        },
        resampleTickerData: function (e, t) {
            e.resampleData(this._sampleRate, this._inputSampleRate, t, this);
        },
        getResampledAudio: function (e, t) {
            return this.getResampledFloats(e, t, this._sampleRate, this._inputSampleRate);
        },
        getResampledFloats: function (e, t, i, a) {
            var r;
            if (i == a) r = this.getCopiedAudio(e, t, this.readFloatSample.bind(this), this._resampleBuffer);
            else {
                var n = (r = Math.round((t * i) / a)) * this._channels;
                n > this._resampleBuffer.length && (this._resampleBuffer = this.allocResampleBuffer(n)),
                    this.resampleToFloat(this._channels, 0, e, t, this.readFloatSample.bind(this), this._resampleBuffer, r),
                    2 == this._channels && this.resampleToFloat(this._channels, 1, e, t, this.readFloatSample.bind(this), this._resampleBuffer, r);
            }
            return r;
        },
        resampleToFloat: function (e, t, i, a, r, n, s) {
            for (var o, d = 0, l = 0, c = s - 0, h = a - 0, u = Math.abs(c - d), f = d < c ? 1 : -1, p = -Math.abs(h - l), _ = l < h ? 1 : -1, m = u + p; (n[d * e + t] = r(i, l * e + t)), !(c <= d && h <= l);)
                p < (o = 2 * m) && ((m += p), (d += f)), o < u && ((m += u), (l += _));
        },
        getResampleBuffer: function () {
            return this._resampleBuffer;
        },
    }),
    (EmsHEAP16BackendAdapter = (function () {
        var i = function (e, t) {
            i.base.call(this, t, 2),
                (this.Module = e),
                (this.Module.adapterCallback = function () {
                    this.doOnAdapterReady(), this.notifyAdapterReady();
                }.bind(this)),
                window.Math.fround || (window.Math.fround = window.Math.round);
        };
        return (
            extend(AudioBackendAdapterBase, i, {
                doOnAdapterReady: function () { },
                isAdapterReady: function () {
                    return void 0 === this.Module.notReady || !this.Module.notReady;
                },
                registerEmscriptenFileData: function (e, t) {
                    try {
                        this.Module.FS_createPath("/", e[0], !0, !0);
                    } catch (e) { }
                    var i;
                    try {
                        i = this.Module.FS_createDataFile(e[0], e[1], t, !0, !0);
                        ScriptNodePlayer.getInstance().trace("registerEmscriptenFileData: [" + e[0] + "][" + e[1] + "] size: " + t.length);
                    } catch (e) { }
                    return i;
                },
                readFloatSample: function (e, t) {
                    return this.Module.HEAP16[e + t] / 32768;
                },
                applyPanning: function (e, t, i) {
                    var a, r, n, s;
                    for (i = (256 * i) / 2, a = 0; a < 2 * t; a += 2) {
                        var o = (((r = this.Module.HEAP16[e + a]) << 8) + (s = ((n = this.Module.HEAP16[e + a + 1]) - r) * i)) >> 8,
                            d = ((n << 8) - s) >> 8;
                        (this.Module.HEAP16[e + a] = o), (this.Module.HEAP16[e + a + 1] = d);
                    }
                },
            }),
            i
        );
    })()),
    (FileCache = function () {
        (this._binaryFileMap = {}), (this._pendingFileMap = {}), (this._isWaitingForFile = !1);
    }),
    (FileCache.prototype = {
        getFileMap: function () {
            return this._binaryFileMap;
        },
        getPendingMap: function () {
            return this._pendingFileMap;
        },
        setWaitingForFile: function (e) {
            this._isWaitingForFile = e;
        },
        isWaitingForFile: function () {
            return this._isWaitingForFile;
        },
        getFile: function (e) {
            var t;
            return e in this._binaryFileMap && (t = this._binaryFileMap[e]), t;
        },
        setFile: function (e, t) {
            (this._binaryFileMap[e] = t), (this._isWaitingForFile = !1);
        },
    });
var ScriptNodePlayer =
    ((PlayerImpl = function (e, t, i, a, r, n, s, o, d) {
        void 0 === e && alert("fatal error: backendAdapter not specified"),
            void 0 === r && alert("fatal error: onPlayerReady not specified"),
            void 0 === n && alert("fatal error: onTrackReadyToPlay not specified"),
            void 0 === s && alert("fatal error: onTrackEnd not specified"),
            2 < e.getChannels() && alert("fatal error: only 1 or 2 output channels supported"),
            (this._backendAdapter = e),
            this._backendAdapter.setObserver(this),
            (this._basePath = t),
            (this._traceSwitch = !1),
            (this._spectrumEnabled = a),
            (this._songInfo = {}),
            (this._onTrackReadyToPlay = n),
            (this._onTrackEnd = s),
            (this._onPlayerReady = r),
            (this._onUpdate = o),
            (this._tickerStepWidth = 256),
            void 0 !== d && d.init(SAMPLES_PER_BUFFER, this._tickerStepWidth),
            (this._externalTicker = d),
            (this._currentTick = 0),
            this._sourceBuffer,
            this._sourceBufferLen,
            (this._numberOfSamplesRendered = 0),
            (this._numberOfSamplesToRender = 0),
            (this._sourceBufferIdx = 0),
            (this._currentPlaytime = 0),
            (this._currentTimeout = -1),
            this.isAutoPlayCripple() || (setGlobalWebAudioCtx(), (this._sampleRate = window._gPlayerAudioCtx.sampleRate), (this._correctSampleRate = this._sampleRate), this._backendAdapter.resetSampleRate(this._sampleRate, -1)),
            this._bufferSource,
            this._gainNode,
            this._analyzerNode,
            this._scriptNode,
            (this._freqByteData = 0),
            (this._pan = null),
            (window.fileRequestCallback = this.fileRequestCallback.bind(this)),
            (window.fileSizeRequestCallback = this.fileSizeRequestCallback.bind(this)),
            (window.songUpdateCallback = this.songUpdateCallback.bind(this)),
            (this._isPaused = !1),
            (this._isPlayerReady = !1),
            (this._isSongReady = !1),
            (this._initInProgress = !1),
            (this._preLoadReady = !1),
            (window.player = this),
            window.player.preloadFiles.bind(window.player)(
                i,
                function () {
                    (this._preLoadReady = !0), this._preLoadReady && this._backendAdapter.isAdapterReady() && this._backendAdapter.isManualSetupComplete() && ((this._isPlayerReady = !0), this._onPlayerReady());
                }.bind(this)
            );
    }),
        (PlayerImpl.prototype = {
            notify: function () {
                if (void 0 !== this.deferredPreload && this._backendAdapter.isAdapterReady()) {
                    var e = this.deferredPreload[0],
                        t = this.deferredPreload[1];
                    delete this.deferredPreload, this.preload(e, e.length, t);
                }
                !this._isPlayerReady && this._preLoadReady && this._backendAdapter.isAdapterReady() && this._backendAdapter.isManualSetupComplete() && ((this._isPlayerReady = !0), this._onPlayerReady());
            },
            handleBackendEvent: function () {
                this.notify();
            },
            isReady: function () {
                return this._isPlayerReady;
            },
            setTraceMode: function (e) {
                this._traceSwitch = e;
            },
            play: function () {
                this._isPaused = !1;
                try {
                    this._bufferSource.start(0);
                } catch (e) { }
            },
            pause: function () {
                ScriptNodePlayer.getInstance().setVolume(0);
                this.isWaitingForFile() || this._initInProgress || !this._isSongReady || (this._isPaused = !0);
            },
            isPaused: function () {
                return this._isPaused;
            },
            resume: function () {
                ScriptNodePlayer.getInstance().setVolume(1);
                this.isWaitingForFile() || this._initInProgress || !this._isSongReady || this.play();
            },
            getCurrentTick: function () {
                var e = Math.ceil(SAMPLES_PER_BUFFER / this._tickerStepWidth) - 1;
                return (e = Math.min(e, this._currentTick));
            },
            setVolume: function (e) {
                void 0 !== this._gainNode && (this._gainNode.gain.value = e);
            },
            getVolume: function () {
                return void 0 !== this._gainNode ? this._gainNode.gain.value : -1;
            },
            setPanning: function (e) {
                this._pan = e;
            },
            isStereo: function () {
                return 2 == this._backendAdapter.getChannels();
            },
            toggleVoices: function(v) {
                this._backendAdapter.enableVoices(v);
            },
            getSongInfo: function () {
                return this._songInfo;
            },
            getSongInfoMeta: function () {
                return this._backendAdapter.getSongInfoMeta();
            },
            setPlaybackTimeout: function (e) {
                (this._currentPlaytime = 0), (this._currentTimeout = e < 0 ? -1 : (e / 1e3) * this._correctSampleRate);
            },
            getPlaybackTimeout: function () {
                return this._currentTimeout < 0 ? -1 : Math.round(this._currentTimeout / this._correctSampleRate);
            },
            getCurrentPlaytime: function () {
                return Math.round(this._currentPlaytime / this._correctSampleRate);
            },
            getFreqByteData: function () {
                return this._analyzerNode && (0 === this._freqByteData && (this._freqByteData = new Uint8Array(this._analyzerNode.frequencyBinCount)), this._analyzerNode.getByteFrequencyData(this._freqByteData)), this._freqByteData;
            },
            getMaxPlaybackPosition: function () {
                return this._backendAdapter.getMaxPlaybackPosition();
            },
            getPlaybackPosition: function () {
                return this._backendAdapter.getPlaybackPosition();
            },
            seekPlaybackPosition: function (e) {
                return this._backendAdapter.seekPlaybackPosition(e);
            },
            loadMusicFromTmpFile: function (e, a, r, n, t) {
                this.initByUserGesture();
                var s = e.name;
                this._fileReadyNotify = "";
                var o = (a.basePath ? a.basePath : this._basePath) + s;
                if (!this.loadMusicDataFromCache(o, a, n)) {
                    var d = new FileReader();
                    (d.onload = function () {
                        var e = this._backendAdapter.getPathAndFilename(s),
                            t = new Uint8Array(d.result);
                        if (void 0 !== this._backendAdapter.registerFileData(e, t)) {
                            var i = this._backendAdapter.mapCacheFileName(o);
                            this.getCache().setFile(i, t), this.prepareTrackForPlayback(o, d.result, a), r(s);
                        } else n();
                    }.bind(this)),
                        (d.onprogress = function (e) {
                            t && t(e.total, e.loaded);
                        }.bind(this)),
                        d.readAsArrayBuffer(e);
                }
            },
            isAppleShit: function () {
                return !!navigator.platform && /iPad|iPhone|iPod/.test(navigator.platform);
            },
            isAutoPlayCripple: function () {
                return window.chrome || this.isAppleShit();
            },
            initByUserGesture: function () {
                if (void 0 === this._sampleRate) setGlobalWebAudioCtx(), (this._sampleRate = window._gPlayerAudioCtx.sampleRate), (this._correctSampleRate = this._sampleRate), this._backendAdapter.resetSampleRate(this._sampleRate, -1);
                else if ("suspended" == window._gPlayerAudioCtx.state)
                    try {
                        window._gPlayerAudioCtx.resume();
                    } catch (e) { }
                if (void 0 !== this._bufferSource)
                    try {
                        this._bufferSource.stop(0);
                    } catch (e) { }
                else {
                    var e = window._gPlayerAudioCtx;
                    this.isAppleShit() && this.iOSHack(e),
                        (this._analyzerNode = e.createAnalyser()),
                        (this._scriptNode = this.createScriptProcessor(e)),
                        (this._gainNode = e.createGain()),
                        (this._delayNode = e.createDelay()),
//                        this._delayNode.delayTime.value = 0.1856,
                        this._delayNode.delayTime.value = 0,
                        this._scriptNode.connect(this._gainNode),
                        void 0 !== this._externalTicker && this.createTickerScriptProcessor(e).connect(this._gainNode),
                        this._spectrumEnabled ? (this._gainNode.connect(this._analyzerNode), this._analyzerNode.connect(this._delayNode)) : this._gainNode.connect(this._delayNode),
                        this._delayNode.connect(e.destination),
                        (this._bufferSource = e.createBufferSource()),
                        this._bufferSource.start || ((this._bufferSource.start = this._bufferSource.noteOn), (this._bufferSource.stop = this._bufferSource.noteOff));
                }
            },
            loadMusicFromURL: function (e, t, i, a, r) {
                this.initByUserGesture();
                var n = this._backendAdapter.mapInternalFilename(t.basePath, this._basePath, e);
                if (((this._fileReadyNotify = ""), !this.loadMusicDataFromCache(n, t, a))) {
                    var s = new XMLHttpRequest();
                    s.open("GET", this._backendAdapter.mapUrl(n), !0),
                        (s.responseType = "arraybuffer"),
                        (s.onload = function (e) {
                            this.trace("loadMusicFromURL successfully loaded: " + n), this.prepareTrackForPlayback(n, s.response, t) ? i(n) : this.isWaitingForFile() || a();
                        }.bind(this)),
                        (s.onprogress = function (e) {
                            r && r(e.total, e.loaded);
                        }.bind(this)),
                        (s.onreadystatuschange = function (e) {
                            4 == oReq.readyState && 404 == oReq.status && this.trace("loadMusicFromURL failed to load: " + n);
                        }.bind(this)),
                        s.send(null);
                        ScriptNodePlayer.getInstance().setVolume(1);
                }
            },
            uploadFile: function (a, r, n, s, t) {
                var o = new FileReader();
                (o.onload = function () {
                    var e = this._backendAdapter.getPathAndFilename(a.name),
                        t = new Uint8Array(o.result);
                    if (void 0 !== this._backendAdapter.registerFileData(e, t)) {
                        var i = this._backendAdapter.uploadFile(a.name, r);
                        0 === i ? (n(a.name), this._onPlayerReady()) : 1 == i && n(a.name);
                    } else s();
                }.bind(this)),
                    (o.onprogress = function (e) {
                        t && t(e.total, e.loaded);
                    }.bind(this)),
                    o.readAsArrayBuffer(a);
            },
            prepareTrackForPlayback: function (e, t, i) {
                return (this._isPaused = !0), (this.lastUsedFilename = e), (this.lastUsedData = t), (this.lastUsedOptions = i), (this._isSongReady = !1), this.setWaitingForFile(!1), this.initIfNeeded(e, t, i);
            },
            trace: function (e) {
                this._traceSwitch && console.log(e);
            },
            setWait: function (e) {
                this.setWaitingForFile(e);
            },
            getDefaultSampleRate: function () {
                return this._correctSampleRate;
            },
            initIfNeeded: function (e, t, i) {
                var a = this.loadMusicData(e, t, i);
                if (a < 0) (this._isSongReady = !1), this.setWaitingForFile(!0), (this._initInProgress = !1);
                else {
                    if (0 === a)
                        return (
                            this.setWaitingForFile(!1),
                            (this._isSongReady = !0),
                            (this._currentPlaytime = 0),
                            (this._initInProgress = !1),
                            this.trace("successfully completed init"),
                            0 !== this._backendAdapter.evalTrackOptions(i)
                                ? (this.trace("error preparing track options"), !1)
                                : (this.updateSongInfo(e), this.lastUsedFilename == e && (this._fileReadyNotify == e ? this.play() : this._onTrackReadyToPlay(), (this._fileReadyNotify = e)), !(this._isPaused = !1))
                        );
                    (this._initInProgress = !1), this.trace("initIfNeeded - fatal error");
                }
                return !1;
            },
            loadMusicDataFromCache: function (e, t, i) {
                (this._currentTimeout = -1), (this._currentPlaytime = 0), (this._isPaused = !0);
                var a = this._backendAdapter.mapCacheFileName(e),
                    r = this.getCache().getFile(a);
                return void 0 !== r && (this.prepareTrackForPlayback(e, r, t) || this.isWaitingForFile() || i(), !0);
            },
            getAudioContext: function () {
                return this.initByUserGesture(), window._gPlayerAudioCtx;
            },
            iOSHack: function (e) {
                try {
                    var t = window._gPlayerAudioCtx.createBufferSource();
                    t.start || ((t.start = t.noteOn), (t.stop = t.noteOff)), (t.buffer = window._gPlayerAudioCtx.createBuffer(1, 1, 22050)), t.connect(window._gPlayerAudioCtx.destination), t.start(0);
                } catch (e) { }
            },
            updateSongInfo: function (e) {
                (this._songInfo = {}), this._backendAdapter.updateSongInfo(e, this._songInfo);
            },
            loadMusicData: function (e, t, i) {
                if ((this._backendAdapter.teardown(), t)) {
                    var a = this._backendAdapter.getPathAndFilename(e),
                        r = new Uint8Array(t);
                    this._backendAdapter.registerFileData(a, r);
                    var n = this._backendAdapter.mapCacheFileName(e);
                    this.getCache().setFile(n, r);
                    var s = this._backendAdapter.loadMusicData(this._sampleRate, a[0], a[1], r, i);
                    return 0 === s && this.resetBuffer(), s;
                }
            },
            resetBuffer: function () {
                (this._numberOfSamplesRendered = 0), (this._numberOfSamplesToRender = 0), (this._sourceBufferIdx = 0);
            },
            resetSampleRate: function (e) {
                this._backendAdapter.resetSampleRate(e, -1), 0 < e && (this._sampleRate = e), this.resetBuffer();
            },
            createScriptProcessor: function (e) {
                var t = e.createScriptProcessor(SAMPLES_PER_BUFFER, 0, this._backendAdapter.getChannels());
                return (t.onaudioprocess = fetchSamples), t;
            },
            createTickerScriptProcessor: function (e) {
                var t;
                return ((t = e.createScriptProcessor(256, 0, 1)).onaudioprocess = calcTick), t;
            },
            fillEmpty: function (e, t, a) {
                var r = e - this._numberOfSamplesRendered;
                for (i = 0; i < r; i++) void (t[i + this._numberOfSamplesRendered] = 0) !== a && (a[i + this._numberOfSamplesRendered] = 0);
                (this._numberOfSamplesToRender = 0), (this._numberOfSamplesRendered = e);
            },
            fileRequestCallback: function (e) {
                var t = this._backendAdapter.mapBackendFilename(e);
                return this.preloadFile(
                    t,
                    function () {
                        this.initIfNeeded(this.lastUsedFilename, this.lastUsedData, this.lastUsedOptions);
                    }.bind(this),
                    !1
                );
            },
            fileSizeRequestCallback: function (e) {
                var t = this._backendAdapter.mapBackendFilename(e),
                    i = this._backendAdapter.mapCacheFileName(t);
                return this.getCache().getFile(i).length;
            },
            songUpdateCallback: function (e) {
                this._backendAdapter.handleBackendSongAttributes(e, this._songInfo), this._onUpdate && this._onUpdate();
            },
            preload: function (e, t, i) {
                if (0 === t) i();
                else {
                    t--;
                    var a = function () {
                        this.preload(e, t, i);
                    }.bind(this);
                    this.preloadFile(e[t], a, !0);
                }
            },
            preloadFile: function (r, n, e) {
                var s = this._backendAdapter.mapCacheFileName(r),
                    t = this.getCache().getFile(s);
                if (void 0 !== t) {
                    var i = 0;
                    return 0 == t && ((i = 1), this.trace("error: preloadFile could not get cached: " + r)), e && n(), i;
                }
                if (((this._isPaused = !0), this.setWaitingForFile(!0), (this._isSongReady = !1), !(s in this.getCache().getPendingMap()))) {
                    this.getCache().getPendingMap()[s] = 1;
                    var o = new XMLHttpRequest();
                    o.open("GET", this._backendAdapter.mapUrl(r), !0),
                        (o.responseType = "arraybuffer"),
                        (o.onload = function (e) {
                            var t = o.response;
                            if (t) {
                                this.trace("preloadFile successfully loaded: " + r);
                                var i = this._backendAdapter.getPathAndFilename(r),
                                    a = new Uint8Array(t);
                                this._backendAdapter.registerFileData(i, a), this.getCache().setFile(s, a);
                            }
                            delete this.getCache().getPendingMap()[s] || this.trace("remove file from pending failed: " + s), n();
                        }.bind(this)),
                        (o.onreadystatuschange = function (e) {
                            4 == o.readyState && 404 == o.status && (this.trace("preloadFile failed to load: " + r), this.getCache().setFile(s, 0));
                        }.bind(this)),
                        (o.onerror = function (e) {
                            this.getCache().setFile(s, 0);
                        }.bind(this)),
                        o.send(null);
                }
                return -1;
            },
            tick: function (e) {
                this._isPaused || this._currentTick++;
            },
            genSamples: function (e) {
                var t,
                    i = this.isStereo() && 1 < e.outputBuffer.numberOfChannels,
                    a = e.outputBuffer.getChannelData(0);
                if ((i && (t = e.outputBuffer.getChannelData(1)), !this._isSongReady || this.isWaitingForFile() || this._isPaused)) {
                    var r;
                    for (r = 0; r < a.length; r++) (a[r] = 0), i && (t[r] = 0);
                } else {
                    void 0 !== this._externalTicker && this._externalTicker.start();
                    var n = a.length;
                    for (this._numberOfSamplesRendered = 0; this._numberOfSamplesRendered < n;) {
                        if (0 === this._numberOfSamplesToRender) {
                            var s;
                            if (
                                (0 < this._currentTimeout && this._currentPlaytime > this._currentTimeout
                                    ? (this.trace("'song end' forced after " + this._currentTimeout / this._correctSampleRate + " secs"), (s = 1))
                                    : ((s = this._backendAdapter.computeAudioSamples()), void 0 !== this._externalTicker && this._externalTicker.computeAudioSamplesNotify()),
                                    0 !== s)
                            )
                                return (
                                    this.fillEmpty(n, a, t),
                                    s < 0
                                        ? ((this._isPaused = !0), (this._isSongReady = !1), void this.setWaitingForFile(!0))
                                        : this.isWaitingForFile()
                                            ? void 0
                                            : (1 < s && this.trace("playback aborted with an error"), (this._isPaused = !0), void (this._onTrackEnd && this._onTrackEnd()))
                                );
                            (this._sourceBuffer = this._backendAdapter.getAudioBuffer()),
                                (this._sourceBufferLen = this._backendAdapter.getAudioBufferLength()),
                                null != this._pan && this._backendAdapter.applyPanning(this._sourceBuffer, this._sourceBufferLen, this._pan + 1),
                                (this._numberOfSamplesToRender = this._backendAdapter.getResampledAudio(this._sourceBuffer, this._sourceBufferLen)),
                                void 0 !== this._externalTicker && this._backendAdapter.resampleTickerData(this._externalTicker, this._sourceBufferLen),
                                (this._sourceBufferIdx = 0);
                        }
                        var o = this._backendAdapter.getResampleBuffer();
                        i ? this.copySamplesStereo(o, a, t, n) : this.copySamplesMono(o, a, n);
                    }
                    this._currentPlaytime += (n * this._correctSampleRate) / this._sampleRate;
                }
                void 0 !== this._externalTicker && (this._externalTicker.calcTickData(a, t), (this._currentTick = 0));
            },
            copySamplesStereo: function (e, t, i, a) {
                var r;
                if (this._numberOfSamplesRendered + this._numberOfSamplesToRender > a) {
                    var n = a - this._numberOfSamplesRendered;
                    for (r = 0; r < n; r++)
                        void 0 !== this._externalTicker && this._externalTicker.copyTickerData(r + this._numberOfSamplesRendered, this._sourceBufferIdx >> 1),
                            (t[r + this._numberOfSamplesRendered] = e[this._sourceBufferIdx++]),
                            (i[r + this._numberOfSamplesRendered] = e[this._sourceBufferIdx++]);
                    (this._numberOfSamplesToRender -= n), (this._numberOfSamplesRendered = a);
                } else {
                    for (r = 0; r < this._numberOfSamplesToRender; r++)
                        void 0 !== this._externalTicker && this._externalTicker.copyTickerData(r + this._numberOfSamplesRendered, this._sourceBufferIdx >> 1),
                            (t[r + this._numberOfSamplesRendered] = e[this._sourceBufferIdx++]),
                            (i[r + this._numberOfSamplesRendered] = e[this._sourceBufferIdx++]);
                    (this._numberOfSamplesRendered += this._numberOfSamplesToRender), (this._numberOfSamplesToRender = 0);
                }
            },
            copySamplesMono: function (e, t, i) {
                var a;
                if (this._numberOfSamplesRendered + this._numberOfSamplesToRender > i) {
                    var r = i - this._numberOfSamplesRendered;
                    for (a = 0; a < r; a++) void 0 !== this._externalTicker && this._externalTicker.copyTickerData(a + this._numberOfSamplesRendered, this._sourceBufferIdx), (t[a + this._numberOfSamplesRendered] = e[this._sourceBufferIdx++]);
                    (this._numberOfSamplesToRender -= r), (this._numberOfSamplesRendered = i);
                } else {
                    for (a = 0; a < this._numberOfSamplesToRender; a++)
                        void 0 !== this._externalTicker && this._externalTicker.copyTickerData(a + this._numberOfSamplesRendered, this._sourceBufferIdx), (t[a + this._numberOfSamplesRendered] = e[this._sourceBufferIdx++]);
                    (this._numberOfSamplesRendered += this._numberOfSamplesToRender), (this._numberOfSamplesToRender = 0);
                }
            },
            preloadFiles: function (e, t) {
                (this._isPaused = !0), this._backendAdapter.isAdapterReady() ? this.preload(e, e.length, t) : (this.deferredPreload = [e, t]);
            },
            setWaitingForFile: function (e) {
                this.getCache().setWaitingForFile(e);
            },
            isWaitingForFile: function () {
                return this.getCache().isWaitingForFile();
            },
            getCache: function () {
                return void 0 === window._fileCache && (window._fileCache = new FileCache()), window._fileCache;
            },
        }),
    {
        createInstance: function (e, t, i, a, r, n, s, o, d) {
            var l = !1;
            if (void 0 !== window.player) {
                var c = window.player;
                if (((c._isPaused = !0), void 0 !== c._bufferSource))
                    try {
                        c._bufferSource.stop(0);
                    } catch (e) { }
                c._scriptNode && c._scriptNode.disconnect(0), c._analyzerNode && c._analyzerNode.disconnect(0), c._gainNode && c._gainNode.disconnect(0), (l = c._traceSwitch);
            }
            new PlayerImpl(e, t, i, a, r, n, s, o, d)._traceSwitch = l;
        },
        getInstance: function () {
            return void 0 === window.player && alert("fatal error: window.player not defined"), window.player;
        },
    });


/*********************************************************************************************************************************/
/** mini_display *****************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/

/**
* Simple music visualization for ScriptNodePlayer.
*
* <p>Use SongDisplay to render animated frequency spectrum and basic meta info about the current song.
*
* <p>This file also handles HTML5 <details> and their simulation in Firefox: set "window.openDetails" 
* (before loading this file) to control if "details" are initially open/closed 
*/


/**
* Accessor must be subclassed to define attribute access for a specific backend.
*/
DisplayAccessor = function (doGetSongInfo) {
    this.doGetSongInfo = doGetSongInfo;
};

DisplayAccessor.prototype = {
    getDisplayTitle: function () { },
    getDisplaySubtitle: function () { },
    getDisplayLine1: function () { },
    getDisplayLine2: function () { },
    getDisplayLine3: function () { },

    // ---------------- utilities -----------------
    getSongInfo: function () {
        return this.doGetSongInfo();
    },
};

/*
* This render class drives the "requestAnimationFrame" cycle.
*
* external dependencies:
*	 ScriptNodePlayer.getInstance()
*    document span elements:  name, author, released
*
* @param displayAccessor subclass of DisplayAccessor
* @param colors either the URL to an image or an array containing color strings
* @param barType 0: "growing bars", 1: "jumping bars"
* @param cpuLimit percentage of CPU that can be used for graphics: 0= 0%, 1=100%.. or anything inbetween
* @param doAnimate some function that will be added to the built-in rendering
*/
SongDisplay = function (displayAccessor, colors, barType, cpuLimit, doAnimate) {
    this.displayAccessor = displayAccessor;
    this.doAnimate = doAnimate;

    this.refreshCounter = 0;
    this.lastRenderTime = 0;
    this.worstRenderTime = 0;

    this.timeLimit = 1000 / 60 * cpuLimit;	// renderiung should take no longer than 10% of the available time (e.g. 3-4 millis per frame)

    //this.name = document.getElementById('name');
    //this.author = document.getElementById('author');
    //this.released = document.getElementById('released');
};

SongDisplay.prototype = {
    reqAnimationFrame: function () {
        //window.requestAnimationFrame(this.redraw.bind(this));
    },
    redraw: function () {
        //if(this.doAnimate) this.doAnimate();
        //this.reqAnimationFrame();
    },
    redrawSongInfo: function () {
        //this.reqAnimationFrame();	// start the animation going
        //this.name.innerHTML = this.displayAccessor.getDisplayLine1();
        //this.author.innerHTML = this.displayAccessor.getDisplayLine2();
        //this.released.innerHTML = this.displayAccessor.getDisplayLine3();
    },
};

window.console || (window.console = { 'log': alert });


/*********************************************************************************************************************************/
/** mini_controls ****************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/

/**
* Minimal controls for ScriptNodePlayer.
*
* <p>Features an initial playlist, drag&drop of additional music files, and controls for "play", "pause", 
* "next song", "previous song", "seek" (optional), "volume".
*
* <p>This crude UI is not meant to be reusable but to show how the ScriptNodePlayer is used. ()
*/
BasicPlayerControls = function (songs, enableSeek, enableSpeedTweak, doParseUrl, current, defaultOptions) {
    this._options = (typeof defaultOptions != 'undefined') ? defaultOptions : {};
    this._current = (typeof current != 'undefined') ? current : -1;
    if (Object.prototype.toString.call(songs) === '[object Array]') {
        this._someSongs = songs;
    } else {
        console.log("warning: no valid song list supplied.. starting empty");
        this._someSongs = [];
    }
    this._enableSeek = enableSeek;
    this._enableSpeedTweak = enableSpeedTweak;
    this._doParseUrl = doParseUrl;

    this.initDomElements();
};

BasicPlayerControls.prototype = {
    // facade for player functionality so that BasicPlayerControls user does not also need to know the player
    pause: function () { 
        sidDisplay.stopAnim();
        ScriptNodePlayer.getInstance().pause();
    },
    resume: function () { 
        sidDisplay.startAnim(); 
        ScriptNodePlayer.getInstance().resume(); 
    },
    setVolume: function (value) { ScriptNodePlayer.getInstance().setVolume(value); },
    getSongInfo: function () { return ScriptNodePlayer.getInstance().getSongInfo(); },
    getCurrentPlaytime: function () { return ScriptNodePlayer.getInstance().getCurrentPlaytime(); },

    addSong: function (filename) {
        this._someSongs.push(filename);
    },
    seekPos: function (relPos) {
        var p = ScriptNodePlayer.getInstance();
        p.seekPlaybackPosition(Math.round(p.getMaxPlaybackPosition() * relPos));
    },
    // some playlist handling
    removeFromPlaylist: function (songname) {
        if (this._someSongs[this._current] == songname) {
            this._someSongs.splice(this._current, 1);
            if (this._current + 1 == this._someSongs.length) this._current = 0;
        }
    },
    infoWindow: function () {
        infopane = document.getElementById("infopane");
        infobutton = document.getElementById("info");
        if (infopane.style.visibility == "hidden") {
            infopane.style.visibility = "visible";
            infobutton.style.border = "2px solid rgb(44,200,44)";
        } else {
            infopane.style.visibility = "hidden";
            infobutton.style.border = "2px";
        }
    },
    v1Toggle: function() {
        var voice1Canvas = document.getElementById("voice1Canvas");
        if (v1state == AUDIBLE) {
            v1state=MUTED;
        }
        else {
            v1state=AUDIBLE;
        }
        ScriptNodePlayer.getInstance().toggleVoices( (v4state<<3) | (v3state<<2) | (v2state<<1) | (v1state) );
//        ScriptNodePlayer.getInstance().toggleVoices( 0 );
    },
    v2Toggle: function() {
        var voice2Canvas = document.getElementById("voice2Canvas");
        if (v2state == AUDIBLE) {
            v2state=MUTED;
        }
        else {
            v2state=AUDIBLE;
        }
        ScriptNodePlayer.getInstance().toggleVoices( (v4state<<3) | (v3state<<2) | (v2state<<1) | (v1state) );
    },
    v3Toggle: function() {
        var voice3Canvas = document.getElementById("voice3Canvas");
        if (v3state == AUDIBLE) {
            v3state=MUTED;
        }
        else {
            v3state=AUDIBLE;
        }
        ScriptNodePlayer.getInstance().toggleVoices( (v4state<<3) | (v3state<<2) | (v2state<<1) | (v1state) );
    },
    v4Toggle: function() {
        var voice4Canvas = document.getElementById("voice4Canvas");
        if (v4state == AUDIBLE) {
            v4state=MUTED;
        }
        else {
            v4state=AUDIBLE;
        }
        ScriptNodePlayer.getInstance().toggleVoices( (v4state<<3) | (v3state<<2) | (v2state<<1) | (v1state) );
    },
    shuffleTable: function () {
        nameAsc = false;
        authorAsc = false;
        releasedAsc = false;
        shuffleT();
    },
    playNextSong: function () {
        resetCurrentLength();
        var ready = ScriptNodePlayer.getInstance().isReady();
        if (ready && this._someSongs.length) {
            if (!hasEverPlayed) {
                playSongOnFirstVisibleRow();
            } else {
                var currentRow = document.getElementById("rowID" + activeSongId);
                var startRow = currentRow;
                var nextRow;
                do {
                    if (currentRow.rowIndex + 1 > this._someSongs.length) {
                        nextRow = currentRow.parentNode.rows[ 1 ];
                    } else {
                        nextRow = currentRow.parentNode.rows[ currentRow.rowIndex + 1 ];
                    }
                    currentRow = nextRow;
                } while (nextRow.style.display == "none" && startRow.id != currentRow.id);
                var nextRowSongIndex = nextRow.id.substring(5);
                if (startRow.id != currentRow.id) {
                    updateDomBgColor(songDB[nextRowSongIndex]);
                    this.playSong(songDB[nextRowSongIndex]);
                }
                hasEverPlayed = true;
                isPlaying = true;
                nextRow.scrollIntoView({
                    behavior: 'smooth',
                    block: 'center',
                    inline: 'center'
                });    
            }
        }
    },
    playPreviousSong: function () {
        resetCurrentLength();
        if (ScriptNodePlayer.getInstance().isReady() && this._someSongs.length) {
            if (!hasEverPlayed) {
                playSongOnFirstVisibleRow();
            } else {
                var currentRow = document.getElementById("rowID" + activeSongId);
                var startRow = currentRow;
                var prevRow;
                do {
                    if (currentRow.rowIndex - 1 < 1) {
                        var prevRow = currentRow.parentNode.rows[ this._someSongs.length ];
                    } else {
                        var prevRow = currentRow.parentNode.rows[ currentRow.rowIndex - 1 ];
                    }
                    currentRow = prevRow;    
                } while (prevRow.style.display == "none" && startRow.id != currentRow.id);
                var nextRowSongIndex = prevRow.id.substring(5);
                if (startRow.id != currentRow.id) {
                    updateDomBgColor(songDB[nextRowSongIndex]);
                    this.playSong(songDB[nextRowSongIndex]);
                }
                hasEverPlayed = true;
                isPlaying = true;
                prevRow.scrollIntoView({
                    behavior: 'smooth',
                    block: 'center',
                    inline: 'center'
                });    
            }
        }
    },
    playSongWithBackand: function (options, onSuccess) {
        // backend adapter to be used has been explicitly specified	
        var o = options.backendAdapter;
        ScriptNodePlayer.createInstance(o.adapter, o.basePath, o.preload, o.enableSpectrum,
            onSuccess, o.doOnTrackReadyToPlay, o.doOnTrackEnd);
    },
    playSong: function (someSong) {
/*
        var audioCtx = ScriptNodePlayer.getInstance().getAudioContext();	// handle Google's bullshit "autoplay policy"
        if (audioCtx.state == "suspended") {
            var modal = document.getElementById('autoplayConfirm');
            modal.style.display = "block";		// force user to click

            window.globalDeferredPlay = function () {	// setup function to be used "onClick"
                audioCtx.resume();
                this._playSong(someSong);
            }.bind(this);

        } else {
            this._playSong(someSong);
        }
*/
        v1state = AUDIBLE;
        v2state = AUDIBLE;
        v3state = AUDIBLE;
        v4state = AUDIBLE;
        ScriptNodePlayer.getInstance().toggleVoices( (v4state<<3) | (v3state<<2) | (v2state<<1) | (v1state) );

        this._playSong(someSong);

        if ('mediaSession' in navigator) {
            navigator.mediaSession.metadata = new MediaMetadata({
              title: someSong.name,
              artist: someSong.author,
              album: someSong.released,
              artwork: [
                { src: 'mosnotes.png',   sizes: '32x32',   type: 'image/png' },
              ]
            });
        }
        noSleep.enable();
        
    },
    _playSong: function (someSong) {
        var arr = this._doParseUrl(someSong);
        var options = arr[1];
        if (typeof options.backendAdapter != 'undefined') {
            var name = arr[0];
            var o = options.backendAdapter;
            this.playSongWithBackand(options, (function () {
                var p = ScriptNodePlayer.getInstance();

                p.loadMusicFromURL(name, options,
                    (function (filename) {
                    }),
                    (function () {
                        this.removeFromPlaylist(someSong);	/* no point trying to play this again */
                    }.bind(this)),
                    (function (total, loaded) { }));

                o.doOnPlayerReady();
            }.bind(this)));
        } else {
            var p = ScriptNodePlayer.getInstance();
            if (p.isReady()) {
                p.loadMusicFromURL(arr[0], options,
                    (function (filename) { }),
                    (function () { this.removeFromPlaylist(someSong);	/* no point trying to play this again */ }.bind(this)),
                    (function (total, loaded) { }));
            }
        }
    },
    animate: function () {
        // animate playback position slider
        var slider = document.getElementById("seekPos");
        if (slider && !slider.blockUpdates) {
            var p = ScriptNodePlayer.getInstance();
            slider.value = Math.round(255 * p.getPlaybackPosition() / p.getMaxPlaybackPosition());
        }
    },
    initExtensions: function () { },	// to be overridden in subclass
    initUserEngagement: function () {
        // handle Goggle's latest "autoplay policy" bullshit (patch the HTML/Script from here within this
        // lib so that the various existing html files need not be touched)

        var d = document.createElement("DIV");
        d.setAttribute("id", "autoplayConfirm");
        d.setAttribute("class", "modal-autoplay");

        var dc = document.createElement("DIV");
        dc.setAttribute("class", "modal-autoplay-content");

        var p = document.createElement("P");
        var t = document.createTextNode("You may thank the clueless Google Chrome idiots for this useless add-on dialog - without which their \
		user unfriendly browser will no longer play the music (which is the whole point of this page).\
		Click outside of this box to continue.");
        p.appendChild(t);

        dc.appendChild(p);
        d.appendChild(dc);

        document.body.insertBefore(d, document.body.firstChild);


        var s = document.createElement('script');
        s.text = 'var modal = document.getElementById("autoplayConfirm");\
			window.onclick = function(event) {\
				if (event.target == modal) {\
					modal.style.display = "none";\
					if (typeof window.globalDeferredPlay !== "undefined") { window.globalDeferredPlay();\
					delete window.globalDeferredPlay; }\
				}\
			}';
        document.body.appendChild(s);

    },
    appendControlElement: function (elmt) {
        var controls = document.getElementById("controls");
        controls.appendChild(elmt);
        controls.appendChild(document.createTextNode(" "));  	// spacer
    },
    initDomElements: function () {
        /*
        document.getElementById("voice1Canvas").onpointerdown = this.v1Toggle.bind(this);
        document.getElementById("voice2Canvas").onpointerdown = this.v2Toggle.bind(this);
        document.getElementById("voice3Canvas").onpointerdown = this.v3Toggle.bind(this);
        document.getElementById("voice4Canvas").onpointerdown = this.v4Toggle.bind(this);
        */
        var info = document.createElement("BUTTON");
        info.id = "info";
        info.onpointerdown = this.infoWindow.bind(this);

        var shuffle = document.createElement("BUTTON");
        shuffle.id = "shuffle";
        shuffle.onpointerdown = this.shuffleTable.bind(this);

        var previous = document.createElement("BUTTON");
        previous.id = "previous";
        previous.onpointerdown = this.playPreviousSong.bind(this);

        var pauseplay = document.createElement("BUTTON");
        pauseplay.id = "pauseplay";
        pauseplay.onpointerdown = function (e) {
            if (!hasEverPlayed) {
                playSongOnFirstVisibleRow();
            } else if (!isPlaying) {
                this.resume();
				var activeRow = document.getElementById("rowID"+activeSongId);
				activeRow.scrollIntoView({
					behavior: 'smooth',
					block: 'center',
					inline: 'center'
				});
                isPlaying = true;
            } else if (isPlaying) {
                this.pause();
                isPlaying = false;
            }
        }.bind(this);

/*
        var pause = document.createElement("BUTTON");
        pause.id = "pause";
        pause.onclick = function (e) { this.pause(); }.bind(this);
        this.appendControlElement(pause);
*/

        var next = document.createElement("BUTTON");
        next.id = "next";
        next.onpointerdown = this.playNextSong.bind(this);

        this.appendControlElement(next);
        this.appendControlElement(pauseplay);
//        this.appendControlElement(previous);
        this.appendControlElement(shuffle);
        this.appendControlElement(info);


        /*
        var gain = document.createElement("input");
        gain.id = "gain";
        gain.name = "gain";
        gain.type = "range";
        gain.min = 0;
        gain.max = 255;
        gain.value = 255;
        gain.setAttribute("data-orientation", "vertical");
        gain.oninput = function (e) { this.setVolume(gain.value / 255); }.bind(this);
        this.appendControlElement(gain);
*/
        if (this._enableSeek) {
            var seek = document.createElement("input");
            seek.type = "range";
            seek.min = 0;
            seek.max = 255;
            seek.value = 0;
            seek.id = "seekPos";
            seek.name = "seekPos";
            // FF: 'onchange' triggers once the final value is selected; 
            // Chrome: already triggers while dragging; 'oninput' does not exist in IE 
            // but supposedly has the same functionality in Chrome & FF
            seek.oninput = function (e) {
                if (window.chrome)
                    seek.blockUpdates = true;
            };
            seek.onchange = function (e) {
                if (!window.chrome)
                    seek.onmouseup(e);
            };
            seek.onmouseup = function (e) {
                var p = ScriptNodePlayer.getInstance();
                this.seekPos(seek.value / 255);
                seek.blockUpdates = false;
            }.bind(this);
            this.appendControlElement(seek);
        }
        if (this._enableSpeedTweak) {
            var speed = document.createElement("input");
            speed.type = "range";
            speed.min = 0;
            speed.max = 100;
            speed.value = 50;
            speed.id = "speed";
            speed.name = "speed";
            speed.onchange = function (e) {
                if (!window.chrome)
                    speed.onmouseup(e);
            };

            speed.onmouseup = function (e) {
                var p = ScriptNodePlayer.getInstance();

                var tweak = 0.2; 			// allow 20% speed correction
                var f = (speed.value / 50) - 1;	// -1..1

                var s = p.getDefaultSampleRate();
                s = Math.round(s * (1 + (tweak * f)));
                p.resetSampleRate(s);
            }.bind(this);
            this.appendControlElement(speed);
        }

        //this.initUserEngagement();
        this.initExtensions();

        if ('mediaSession' in navigator) {
            navigator.mediaSession.setActionHandler('play', () => { 
                if (!hasEverPlayed) {
                    playSongOnFirstVisibleRow();
                } else if (!isPlaying) {
                    this.resume();
                    var activeRow = document.getElementById("rowID"+activeSongId);
                    activeRow.scrollIntoView({
                        behavior: 'smooth',
                        block: 'center',
                        inline: 'center'
                    });
                    isPlaying = true;
                }
            });
            navigator.mediaSession.setActionHandler('pause', () => { this.pause(); });
            navigator.mediaSession.setActionHandler('stop', () => { this.pause(); });
            navigator.mediaSession.setActionHandler('seekbackward', () => { /* Code excerpted. */ });
            navigator.mediaSession.setActionHandler('seekforward', () => { /* Code excerpted. */ });
            navigator.mediaSession.setActionHandler('seekto', () => { /* Code excerpted. */ });
            navigator.mediaSession.setActionHandler('previoustrack', () => { this.playPreviousSong(); });
            navigator.mediaSession.setActionHandler('nexttrack', () => { this.playNextSong(); });
            navigator.mediaSession.setActionHandler('skipad', () => { /* Code excerpted. */ });
        }
    }
};


/*********************************************************************************************************************************/
/** sid_tracer *******************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/

/**
* Simple "ticker" plugin that serves as an example for how the AbstractTicker API
* can be used to extend the scriptprocessor_player.js (see ScriptNodePlayer.createInstance) 
*
* It is designed for use with the backend_tinyrsid.js and provides the "realtime" raw data of the 
* underlying SID voices corresponding to the music played via WebAudio.
*
* Underlying/addressed problems: 
*
* 1) The scriptprocessor_player.js uses WebAudio with an audio buffer size of 8192 samples. This
* relatively large buffer reduces the likelyhood that music playback runs out of data (and suddenly 
* starts stuttering). At 44100Hz that amount of data will last for 0.186 secs and WebAudio will request 
* a new buffer some time *before* it actually needs it. This makes it rather hard to make data usage 
* timings that require a higher precision (e.g. to display in "realtime" what is being played back).
*
* 2) The underlying emulator creating the "audio samples" does so with a specific playback frequency in 
* mind (e.g. 48000Hz) and there is a specific batch size that it produces with every call (e.g. 882 
* samples). WebAudio may be running at 41100Hz instead and when it asks for another chunk of 8192 samples
* these are served by calling the emulator, resampling its output to the WebAudio playback frequency and 
* repeating that process until enough data has been collected in WebAudio's audio buffer.
*
* Solution concept:
* 
* The infrastructure needed to deal with the above is implemented within scriptprocessor_player.js: 
*
* 1) An additional "timing node" is introduced into the WebAudio configuration. This node runs with the 
* same frequency and in-sync with the node that actually produces the music. But contrary to the "music 
* node" this "timing node" uses a small 256 samples buffer. This means that it will run out of data 32 times
* more quickly (its data here only lasts for 0.0058 secs). Its requests for new data are used to calculate
* how far WebAudio has advanced in its audio buffer playback. 
*
* 2) The emulator generates add-on data with the exact same granulatory as the audio samples, i.e. if there is
* one audio sample then there is exactly on element of some type of add-on data (respective output arrays 
* have the same size). Whatever transformations are later done with the audio buffer (see 2. above) are also 
* performed with the add-on data. Since the add-on data is backend specific it cannot be done directly 
* within the scriptprocessor_player.js but instead scriptprocessor_player.js delegates the backend specific 
* stuff to a backend specific subclass of AbstractTicker. The below SidTracer is such a subclass.
*
* Functionality:
*
* This implementation provides a view into the past. Its getters do NOT provide data that will be played in 
* the future (eventhough *some* of it may already be available in the buffers..). The respective view 
* may reach back into the past for up to 8192 samples and includes the sample data that is played just now (within 
* the "256 samples" precision limitation).
*
*
* version 1.0
*
* 	Copyright (C) 2018 Juergen Wothke
*
* Terms of Use: This file is free software. (Other licenses may apply to the remaining 
* files used in this example.)
*/
SidTracer = (function () {
    var $this = function (outputSize) {
        $this.base.call(this);

        this.outputSize = outputSize;
    };
    extend(AbstractTicker, $this, {

        // ------------ APIs expected by the base infractructure - see doc in AbstractTicker parent class -----------------

        /*
        * Basic initialization: 4 kinds of add-on data (voice 1-4) are use here, and for each of these
        *                       3  buffers are used during precessing (see "step" comments below)
        */
        init: function (samplesPerBuffer, tickerStepWidth) {
            this._tickerStepWidth = tickerStepWidth;
            this._samplesPerBuffer = samplesPerBuffer;
            this._backendAdapter; 	// initialized later

            // 1st step: make sure same resampling is used for "add-on data" (as is used for the audio data)
            this._resampleV1 = new Float32Array(samplesPerBuffer);
            this._resampleV2 = new Float32Array(samplesPerBuffer);
            this._resampleV3 = new Float32Array(samplesPerBuffer);
            this._resampleV4 = new Float32Array(samplesPerBuffer);	// the "digi channel"


            // 2nd step: "add-on" buffers in sync with the WebAudio audio buffer.
            // 			 use double buffering to allow smooth transitions at buffer boundaries
            //           (2 buffers are sufficient for the sliding window impl of a "past & present" view )
            this._activeBufIdx = 0;
            this._buffers = [
                [new Float32Array(samplesPerBuffer),		// voice 1 
                new Float32Array(samplesPerBuffer), 	// voice 2
                new Float32Array(samplesPerBuffer), 	// voice 3
                new Float32Array(samplesPerBuffer)],	// digi

                [new Float32Array(samplesPerBuffer),		// voice 1 
                new Float32Array(samplesPerBuffer), 	// voice 2
                new Float32Array(samplesPerBuffer), 	// voice 3
                new Float32Array(samplesPerBuffer)]	// digi
            ];

            // 3rd step: use "sliding window" approach to fill the actual output buffers
            this.setOutputSize(this.outputSize);
        },
        /**
        * Marks the start of a new audio buffer, i.e. a new audio buffer is about to be generated.
        */
        start: function () {
            // alternate used output buffers (as base for "sliding window" data access) 			
            this._activeBufIdx = (this._activeBufIdx ? 0 : 1);
        },
        /**
        * Corresponds to one emulator call - after which resampling of its output is required.
        */
        resampleData: function (sampleRate, inputSampleRate, inputLen, backendAdapter) {

            this._backendAdapter = backendAdapter; // not the best place for this ...

            // this makes sure that the raw data is still in sync after the resampling of the audio data (emulator output)			
            var resampleLen;
            if (sampleRate == inputSampleRate) {
                resampleLen = inputLen;
            } else {
                resampleLen = Math.round(inputLen * sampleRate / inputSampleRate);
            }

            // cache resampled data in more accessible form (allocated size will quickly stabilize)
            this._resampleV1 = this._assertBuffer(backendAdapter, this._resampleV1, resampleLen);
            this._resampleV2 = this._assertBuffer(backendAdapter, this._resampleV2, resampleLen);
            this._resampleV3 = this._assertBuffer(backendAdapter, this._resampleV3, resampleLen);
            this._resampleV4 = this._assertBuffer(backendAdapter, this._resampleV4, resampleLen);

            // resample the add-on data if necessary
            this._resample(backendAdapter.getBufferVoice1(), inputLen, this._resampleV1, resampleLen, backendAdapter);
            this._resample(backendAdapter.getBufferVoice2(), inputLen, this._resampleV2, resampleLen, backendAdapter);
            this._resample(backendAdapter.getBufferVoice3(), inputLen, this._resampleV3, resampleLen, backendAdapter);
            this._resample(backendAdapter.getBufferVoice4(), inputLen, this._resampleV4, resampleLen, backendAdapter);
        },
        /**
        * Mirrors the transfer of the resampled audio data into WebAudio's audio buffer.
        */
        copyTickerData: function (outBufferIdx, inBufferIdx) {
            // the buffers filled here then are in sync with the respective audio data buffer used by WebAudio 
            var buf = this._buffers[this._activeBufIdx];

            buf[0][outBufferIdx] = this._resampleV1[inBufferIdx];
            buf[1][outBufferIdx] = this._resampleV2[inBufferIdx];
            buf[2][outBufferIdx] = this._resampleV3[inBufferIdx];
            buf[3][outBufferIdx] = this._resampleV4[inBufferIdx];
        },

        // ------------ API specifically provided by SidTracer (invent whatever accessors you need here) -----------------

        /*
        * Sets the size of the backward-view (in number of samples). Cannnot be larger than this._samplesPerBuffer
        */
        setOutputSize(s) {
            if (s > this._samplesPerBuffer) {
                console.log("error: max output size is " + this._samplesPerBuffer);
                s = this._samplesPerBuffer;
            }
            this.outputSize = s;

            if ((typeof this._outputV1 == 'undefined') || (this._outputV1.length != s)) {
                this._outputV1 = new Float32Array(s);
                this._outputV2 = new Float32Array(s);
                this._outputV3 = new Float32Array(s);
                this._outputV4 = new Float32Array(s);	// the "digi channel"
            }
        },

        /*
        * NOTE: due to the fact that the below functions return a fixed size "sliding window" of 
        * data, the data returned by successive calls may overlap - or be disjoint when calls are 
        * spaced too far apart.. 
        *
        * In order to let the caller collect/append data (e.g. to display some zoomed-out
        * range) it might be useful to have other APIs, e.g. that deliver only new data or
        * give some feedback with "tick" related info - so that the caller may perform the
        * respective calculations himself, etc. But for now I leave that as an exercise to the reader.
        */
        getDataVoice1: function () {
            this._copySlidingWindow(0, this._outputV1);
            return this._outputV1;
        },
        getDataVoice2: function () {
            this._copySlidingWindow(1, this._outputV2);
            return this._outputV2;
        },
        getDataVoice3: function () {
            this._copySlidingWindow(2, this._outputV3);
            return this._outputV3;
        },
        getDataVoice4: function () {
            this._copySlidingWindow(3, this._outputV4);
            return this._outputV4;
        },
        getRegisterSID: function (reg) {
            return (typeof (this._backendAdapter) == 'undefined') ? 'undefined' : this._backendAdapter.getRegisterSID(reg);
        },
        /**
        * Gets ID of the currently detected digi sample approach (if any).
        * @return 
            0= no digi
            1= legacy 4-bit D418 approach
            2= Mahoney's "8-bit" D418 samples
            3= frequency modulation; e.g. Vicious_SID_2-15638Hz.sid, LMan - Vortex.sid, etc
            4= older PWM impls, e.g. Bla_Bla.sid, Bouncy_Balls_RCA_Intro.sid
            5= newer test-bit based PWM; e.g. Wonderland_XII-Digi_part_1.sid, GhostOrGoblin.sid, etc
            6= 2-bit waveform modulation approach; e.g. IceGuys
        */
        getDigiType: function () {
            return (typeof (this._backendAdapter) == 'undefined') ? 'undefined' : this._backendAdapter.getDigiType();
        },
        /**
        * Gets a short text identifier corresonding to the getDigiType() ID.
        */
        getDigiTypeDesc: function () {
            return (typeof (this._backendAdapter) == 'undefined') ? 'undefined' : this._backendAdapter.getDigiTypeDesc();
        },
        getDigiRate: function () {
            return (typeof (this._backendAdapter) == 'undefined') ? 'undefined' : this._backendAdapter.getDigiRate();
        },


        // ------------------------- private utility functions ---------------------------

        _resample: function (inputPtr, inputLen, resampledBuffer, resampleLen, backendAdapter) {
            if (resampleLen == inputLen) {
                backendAdapter.getCopiedAudio(inputPtr, inputLen, backendAdapter.readFloatSample.bind(backendAdapter), resampledBuffer);
            } else {
                backendAdapter.resampleToFloat(1, 0, inputPtr, inputLen, backendAdapter.readFloatSample.bind(backendAdapter), resampledBuffer, resampleLen);
            }
        },
        _assertBuffer: function (backendAdapter, buf, size) {
            if (size > buf.length) { buf = backendAdapter.allocResampleBuffer(size); }
            return buf;
        },
        _copySlidingWindow: function (voiceId, destBuffer) {
            var bufs = this._buffers[this._activeBufIdx];
            var prevBufs = this._buffers[this._activeBufIdx ? 0 : 1];	// previous buffers

            var inputBuf = bufs[voiceId];
            var prevInputBuf = prevBufs[voiceId];

            var outputLen = destBuffer.length;

            // this is the crucial bit that tells where in the data is *NOW* (below is just an example
            // of how that information might be used)
            var endOffset = (ScriptNodePlayer.getInstance().getCurrentTick() + 1) * this._tickerStepWidth;

            if (endOffset > outputLen) {
                // no buffer boundary crossed (simple copy from the current buffer does the job)
                this._arrayCopy(inputBuf, endOffset - outputLen, outputLen, destBuffer, 0);
            } else {
                // some data still must be fetched from the previous buffer
                var sizePrevious = outputLen - endOffset;
                this._arrayCopy(prevInputBuf, prevInputBuf.length - sizePrevious, sizePrevious, destBuffer, 0);

                this._arrayCopy(inputBuf, 0, endOffset, destBuffer, sizePrevious);
            }
        },
        // caution: does not check boundary violations - you better know what you are doing
        _arrayCopy(src, srcOffset, len, dest, destOffset) {
            // riddiculous that this kind of function does not come with this joke of a 
            // language (and I am not talking about the expensive reallocation workarounds..)

            for (var i = 0; i < len; i++) {
                dest[destOffset + i] = src[srcOffset + i];
            }
        }
    }); return $this;
})();


/*
* Example for how to access SID register data.
*/
RegDisplay = function (spanId, tracer) {
    this.span = document.getElementById(spanId);
    this.sidTracer = tracer;
};

RegDisplay.prototype = {
    reqAnimationFrame: function () {
        window.requestAnimationFrame(this.redraw.bind(this));
    },
    printReg: function (reg) {
        var v = this.sidTracer.getRegisterSID(reg);
        return (v < 0x10) ? "0" + v.toString(16) : v.toString(16);	// pad to 2 chars
    },
    redrawText: function () {
        this.span.innerHTML =
            "<br>SID regs: " + this.printReg(0) +
            " " + this.printReg(1) +
            " " + this.printReg(2) +
            " " + this.printReg(3) +
            " " + this.printReg(4) +
            " " + this.printReg(5) +
            " " + this.printReg(6) +
            " " + this.printReg(7) +
            " " + this.printReg(8) +
            " " + this.printReg(9) +
            " " + this.printReg(10) +
            " " + this.printReg(11) +
            " " + this.printReg(12) +
            " " + this.printReg(13) +
            " " + this.printReg(14) +
            " " + this.printReg(15) +
            " " + this.printReg(16) +
            " " + this.printReg(17) +
            " " + this.printReg(18) +
            " " + this.printReg(19) +
            " " + this.printReg(20) +
            " " + this.printReg(21) +
            " " + this.printReg(22) +
            " " + this.printReg(23) +
            " " + this.printReg(24) +
            (!this.sidTracer.getDigiType() ? "" : "<br>'" + this.sidTracer.getDigiTypeDesc()
                + "' digi samples rate " + this.sidTracer.getDigiRate() + " Hz");

    },
    redraw: function () {
        this.redrawText();
        this.reqAnimationFrame();
    }
};

/**
* Code losely based on C# implementation of SidWiz2 by RushJet1 & Rolf R Bakke (see respective Form1.cs).
*
* note: original implementation included logic for multi-voice/-column layout whereas this implementation
* renders exactely one voice and always uses 1 column. Instead of rendering a
* complete sample file this implementation only renders the frame corresponding to the currently played music.
*
* note: the maximum "scale" that can be used is limited by the size of the sample data array passed to "draw()".
* In order to use the maximum scale make sure the player delivers 16k of sample data..
* 
* note: original implementation used 0-255 integer range sample data - while a -1 to 1 float range is used here.
*/
SidWiz = function (width, height, ctx, altsync) {
    // graphics context to draw in:
    this._resX = width;
    this._resY = height;
    this.ctx = ctx;

    this._voiceData = null;	// new data is fed in for each frame

    this._altSync = altsync;	// enable "alt sync" impl for the voice

    this._scales =  [0.125, 0.25, 0.5, 1, 2, 4, 8, 16];
    this._centers = [32, 16, 8, 4, 2, 1, 0.5, 0.25];
};

SidWiz.prototype = {
    getTriggerLevel: function (jua, jac, offset) {
        // scan for peak values
        var yMax = -1;    	// was 0
        var yMin = 1;		// was 255
        var juaHalf = Math.floor(jua / 2);
        var s = juaHalf - jac;
        for (var h = s; h <= (juaHalf + jac); h++) {	// uses 2 center frames.. ?
            var value = this._voiceData[offset + h];
            if (value > yMax) { yMax = value; }
            if (value < yMin) { yMin = value; }
        }
        return ((yMin + yMax) / 2);   //the middle line of the waveform
    },
    draw: function (data, scaleIdx) {
        var sampleRate = window._gPlayerAudioCtx.sampleRate;	// anyway depends on 'ticker' infrastructure from scriptprocessor_player.js (so this addition doesn't hurt)

        this._voiceData = data;

        var scale = this._scales[scaleIdx];
        var center = this._centers[scaleIdx];

        // note: the crappy variable naming of the original implementation has been
        // largely preserved to ease complarisons..

        var jumpAmount = (sampleRate / 60);         	// samples per frame (no need to use browser's actual framerate)		
        var jua = jumpAmount * Math.floor(1 + scale);	// jua is the size of sample data used per frame

        var oldY2 = 0;
        var newY2 = 0;
        var newX = 0;
        var oldX = 0;	// was called "oldZ" in original impl (probably to reflect its use in 3-byte pixel logic)

        // offset to the position of the 1st sample
        // note: the below logic expects that "jua" samples can be read starting at that position
        var offset = (data.length - jua);

        //jac is the search window
        var jac = jumpAmount;

        var triggerLevel = this.getTriggerLevel(jua, jac, offset);

        var c = scaleIdx <= 4 ? 0 : 2 * jac;	// correction seems to be needed to properly position the displayed range...

        var frameTriggerOffset = 0;

        // syncronization
        if (this._altSync == false) {
            var one = 2.0 / 255;		// adjust original logic to the sample data range used here..
            var triggerLevelM = triggerLevel - one;
            var triggerLevelP = triggerLevel + one;

            frameTriggerOffset = jac;

            while (this._voiceData[offset + c + frameTriggerOffset] < (triggerLevelP) && frameTriggerOffset < jac * 2) frameTriggerOffset++;
            while (this._voiceData[offset + c + frameTriggerOffset] >= (triggerLevelM) && frameTriggerOffset < jac * 2) frameTriggerOffset++;
            if (frameTriggerOffset == jac * 2) frameTriggerOffset = 0;

        } else {
            var distances = [];	// array of arrays
            var qx = jac;
            while ((this._voiceData[offset + qx] >= triggerLevel) && (qx < jac * 2)) qx++;
            var ctr;
            while (qx < jac * 2) {
                ctr = qx;
                var isUp = false;
                //find point where crosses midline
                if (this._voiceData[offset + qx] < triggerLevel) {
                    while ((this._voiceData[offset + qx] < triggerLevel) && (qx < jac * 2)) qx++;
                    isUp = true;
                } else {
                    while ((this._voiceData[offset + qx] >= triggerLevel) && (qx < jac * 2)) qx++;
                }

                //add point to data
                if (!isUp) {
                    var data = [qx - ctr, qx];	// difference, position of the offset
                    distances.push(data);
                }
            }

            ctr = 0; //count of highest values
            var highest = [0, 0]; //this will be the highest value

            var data;
            for (data of distances) {
                if (data[0] > highest[0]) {
                    highest = [data[0], data[1]];
                    ctr = 1;
                } else if (data[0] == highest[0]) {
                    highest.push(data[1]);
                    ctr++;
                }
            }
            // at this point "highest" should be a list where the first value is the difference,
            // and the rest are points in order where the difference occurred
            // ctr is the number of same values. if more than 95% it's probably a square wave
            if (ctr != 1) ctr = Math.ceil(ctr / 2.0);
            frameTriggerOffset = highest[ctr];
        }

        // this._resX = 512
        // this._resY = 40
        var ysum = 0.0;
        var adjy = 0;

        // draw waveform
        var oldY2;		// previous y coord

        var xcoords = [];
        var ycoords = [];
        for (var x = 0; (x / (scale / 2)) < this._resX; x++) {
            var vdPos = frameTriggerOffset + c + x - Math.floor(this._resX / center); // note: stabilization causes first "c" samples to be "unusable", i.e. skip them

            if (vdPos < 0) { vdPos = 0; }
            var vdSet = this._voiceData[offset + vdPos];

            var y = Math.floor((vdSet + 1) / 2 * this._resY);	// use full available height (calc adjusted to sample range used here)

            if (x == 0) {
                oldY2 = y;
            }

            newY2 = y;

            if (oldY2 > this._resY) oldY2 = this._resY;
            if (newY2 > this._resY) newY2 = this._resY;
            if (newY2 < 0) newY2 = 0;
            if (oldY2 < 0) oldY2 = 0;

            newX = Math.floor(2 * x / scale);	// called "z" in original code

            if (oldY2 > newY2) { //waveform moved down
                var t = oldY2;
                oldY2 = newY2;
                newY2 = t;
            }

            // draw line
            if (x == 0) {
//                this.ctx.moveTo(newX, (this._resY - newY2) );
                xcoords.push(newX);
                ycoords.push(this._resY - newY2)
            } else {
//                this.ctx.lineTo(newX, (this._resY - newY2) -adjy);
                xcoords.push(newX);
                ycoords.push(this._resY - newY2)
            }
            ysum += (this._resY - newY2);

            oldX = newX;
            oldY2 = y;
        }
        adjy = ysum / this._resX / scale * 2 - this._resY/2;
        //this.ctx.globalCompositeOperation = "lighter";
        //this.ctx.lineWidth = 1;
        //console.log(this.ctx.globalCompositeOperation);

        let max_x = this._resX * (scale / 2);

        this.ctx.shadowOffsetX = 0;
        this.ctx.shadowOffsetY = 0;
        this.ctx.shadowBlur = 16;
        this.ctx.shadowColor = "white";

        this.ctx.moveTo(xcoords[0], ycoords[0] - adjy);
        for (var x = 1; x < max_x; x++) {
            // draw line
            this.ctx.lineTo(xcoords[x], ycoords[x] - adjy);
        }
    }
};


/*
* Example for basic use/rendering of streamed "add-on" data.
*/
VoiceDisplay = function (divId, getDataFunc, altsync) {
    this.divId = divId;
    this.getData = getDataFunc;

    this.canvas = document.getElementById(this.divId);

    this.WIDTH = this.canvas.width;
    this.HEIGHT = this.canvas.height;
    //console.log(this.canvas.width);
    //console.log(this.canvas.height);

    this.ctx = this.canvas.getContext('2d');
    //this.canvas.width = this.WIDTH;
    //this.canvas.height = this.HEIGHT;

    this.sidWiz = new SidWiz(this.WIDTH, this.HEIGHT, this.ctx, altsync);
};

VoiceDisplay.prototype = {
    reqAnimationFrame: function () {
        window.requestAnimationFrame(this.redraw.bind(this));
    },
    redraw: function () {
        this.redrawGraph();
        this.reqAnimationFrame();
    },
    redrawGraph: function (osciloscopeMode, zoom) {
        var data = this.getData();
        try {
            // seems that dumbshit Safari (11.0.1 OS X) uses the fillStyle for "clearRect"!
            this.ctx.fillStyle = "rgba(0, 0, 0, 0.0)";
        } catch (err) { }
        this.ctx.clearRect(0, 0, this.canvas.width, this.canvas.height);
        //this.ctx.fillRect(0, 0, this.canvas.width, this.canvas.height);

        this.ctx.strokeStyle = "rgba(0, 255, 0, 1.0)";
        this.ctx.save();

        if (!osciloscopeMode) {
            // zooming performed by changing abount of delivered data
            var rescale = this.WIDTH / data.length;
            this.ctx.scale(rescale, 1);	// fit all the data into the visible area
        }

        this.ctx.beginPath();
        if (osciloscopeMode) {
            this.sidWiz.draw(data, 2 + zoom);
        } else {
            for (var i = 0; i < data.length; i++) {
                var scale = (data[i] + 1) / 2;					// range 0..1
                var magnitude = scale * this.HEIGHT;

                if (i == 0) {
                    this.ctx.moveTo(i, this.canvas.height - magnitude);
                    //					this.ctx.moveTo(i, magnitude);	// invert Y
                } else {
                    this.ctx.lineTo(i, this.canvas.height - magnitude);
                    //					this.ctx.lineTo(i, magnitude);	// invert Y
                }
            }
        }
        this.ctx.stroke();
        this.ctx.restore();
    }
};

/*********************************************************************************************************************************/
/** backend_tinyrsid *************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/
/*********************************************************************************************************************************/

// "fix-chrome-consolelog" (or else some idiot chrome versions may crash with "Illegal invokation")
(function () {
    var c = window.console.log;
    window.console.log = function () {
        c.apply(window.console, arguments);
    };
    window.printErr = window.console.log;
})();

// create separate namespace for all the Emscripten stuff.. otherwise naming clashes may occur especially when
// optimizing using closure compiler..

window.spp_backend_state_SID = {
    notReady: true,
    adapterCallback: function () { }, // overwritten later
};
window.spp_backend_state_SID["onRuntimeInitialized"] = function () {
    // emscripten callback needed in case async init is used (e.g. for WASM)
    this.notReady = false;
    this.adapterCallback();
}.bind(window.spp_backend_state_SID);

var backend_SID = (function (Module) {
    var a;
    a || (a = typeof Module !== "undefined" ? Module : {});
    var l = {},
        m;
    for (m in a) a.hasOwnProperty(m) && (l[m] = a[m]);
    a.arguments = [];
    a.thisProgram = "./this.program";
    a.quit = function (b, c) {
        throw c;
    };
    a.preRun = [];
    a.postRun = [];
    var n = !1,
        p = !1,
        q = !1,
        r = !1;
    n = "object" === typeof window;
    p = "function" === typeof importScripts;
    q = "object" === typeof process && "function" === typeof require && !n && !p;
    r = !n && !q && !p;
    var t = "";
    function u(b) {
        return a.locateFile ? a.locateFile(b, t) : t + b;
    }
    if (q) {
        t = __dirname + "/";
        var v, w;
        a.read = function (b, c) {
            v || (v = require("fs"));
            w || (w = require("path"));
            b = w.normalize(b);
            b = v.readFileSync(b);
            return c ? b : b.toString();
        };
        a.readBinary = function (b) {
            b = a.read(b, !0);
            b.buffer || (b = new Uint8Array(b));
            assert(b.buffer);
            return b;
        };
        1 < process.argv.length && (a.thisProgram = process.argv[1].replace(/\\/g, "/"));
        a.arguments = process.argv.slice(2);
        "undefined" !== typeof module && (module.exports = a);
        process.on("uncaughtException", function (b) {
            throw b;
        });
        process.on("unhandledRejection", x);
        a.quit = function (b) {
            process.exit(b);
        };
        a.inspect = function () {
            return "[Emscripten Module object]";
        };
    } else if (r)
        "undefined" != typeof read &&
            (a.read = function (b) {
                return read(b);
            }),
            (a.readBinary = function (b) {
                if ("function" === typeof readbuffer) return new Uint8Array(readbuffer(b));
                b = read(b, "binary");
                assert("object" === typeof b);
                return b;
            }),
            "undefined" != typeof scriptArgs ? (a.arguments = scriptArgs) : "undefined" != typeof arguments && (a.arguments = arguments),
            "function" === typeof quit &&
            (a.quit = function (b) {
                quit(b);
            });
    else if (n || p)
        p ? (t = self.location.href) : document.currentScript && (t = document.currentScript.src),
            (t = 0 !== t.indexOf("blob:") ? t.substr(0, t.lastIndexOf("/") + 1) : ""),
            (a.read = function (b) {
                var c = new XMLHttpRequest();
                c.open("GET", b, !1);
                c.send(null);
                return c.responseText;
            }),
            p &&
            (a.readBinary = function (b) {
                var c = new XMLHttpRequest();
                c.open("GET", b, !1);
                c.responseType = "arraybuffer";
                c.send(null);
                return new Uint8Array(c.response);
            }),
            (a.readAsync = function (b, c, e) {
                var d = new XMLHttpRequest();
                d.open("GET", b, !0);
                d.responseType = "arraybuffer";
                d.onload = function () {
                    200 == d.status || (0 == d.status && d.response) ? c(d.response) : e();
                };
                d.onerror = e;
                d.send(null);
            }),
            (a.setWindowTitle = function (b) {
                document.title = b;
            });
    var y = a.print || ("undefined" !== typeof console ? console.log.bind(console) : "undefined" !== typeof print ? print : null),
        z = a.printErr || ("undefined" !== typeof printErr ? printErr : ("undefined" !== typeof console && console.warn.bind(console)) || y);
    for (m in l) l.hasOwnProperty(m) && (a[m] = l[m]);
    l = void 0;
    function A(b) {
        var c;
        c || (c = 16);
        return Math.ceil(b / c) * c;
    }
    var aa = {
        "f64-rem": function (b, c) {
            return b % c;
        },
        debugger: function () {
            debugger;
        },
    },
        B = !1;
    function assert(b, c) {
        b || x("Assertion failed: " + c);
    }
    var I = {
        stackSave: function () {
            C();
        },
        stackRestore: function () {
            D();
        },
        arrayToC: function (b) {
            var c = E(b.length);
            F.set(b, c);
            return c;
        },
        stringToC: function (b) {
            var c = 0;
            if (null !== b && void 0 !== b && 0 !== b) {
                var e = (b.length << 2) + 1;
                c = E(e);
                var d = c,
                    g = G;
                if (0 < e) {
                    e = d + e - 1;
                    for (var h = 0; h < b.length; ++h) {
                        var f = b.charCodeAt(h);
                        if (55296 <= f && 57343 >= f) {
                            var k = b.charCodeAt(++h);
                            f = (65536 + ((f & 1023) << 10)) | (k & 1023);
                        }
                        if (127 >= f) {
                            if (d >= e) break;
                            g[d++] = f;
                        } else {
                            if (2047 >= f) {
                                if (d + 1 >= e) break;
                                g[d++] = 192 | (f >> 6);
                            } else {
                                if (65535 >= f) {
                                    if (d + 2 >= e) break;
                                    g[d++] = 224 | (f >> 12);
                                } else {
                                    if (2097151 >= f) {
                                        if (d + 3 >= e) break;
                                        g[d++] = 240 | (f >> 18);
                                    } else {
                                        if (67108863 >= f) {
                                            if (d + 4 >= e) break;
                                            g[d++] = 248 | (f >> 24);
                                        } else {
                                            if (d + 5 >= e) break;
                                            g[d++] = 252 | (f >> 30);
                                            g[d++] = 128 | ((f >> 24) & 63);
                                        }
                                        g[d++] = 128 | ((f >> 18) & 63);
                                    }
                                    g[d++] = 128 | ((f >> 12) & 63);
                                }
                                g[d++] = 128 | ((f >> 6) & 63);
                            }
                            g[d++] = 128 | (f & 63);
                        }
                    }
                    g[d] = 0;
                }
            }
            return c;
        },
    },
        ba = { string: I.stringToC, array: I.arrayToC };
    function ca(b) {
        var c;
        if (0 === c || !b) return "";
        for (var e = 0, d, g = 0; ;) {
            d = G[(b + g) >> 0];
            e |= d;
            if (0 == d && !c) break;
            g++;
            if (c && g == c) break;
        }
        c || (c = g);
        d = "";
        if (128 > e) {
            for (; 0 < c;) (e = String.fromCharCode.apply(String, G.subarray(b, b + Math.min(c, 1024)))), (d = d ? d + e : e), (b += 1024), (c -= 1024);
            return d;
        }
        a: {
            c = G;
            for (e = b; c[e];)++e;
            if (16 < e - b && c.subarray && J) b = J.decode(c.subarray(b, e));
            else
                for (e = ""; ;) {
                    d = c[b++];
                    if (!d) {
                        b = e;
                        break a;
                    }
                    if (d & 128)
                        if (((g = c[b++] & 63), 192 == (d & 224))) e += String.fromCharCode(((d & 31) << 6) | g);
                        else {
                            var h = c[b++] & 63;
                            if (224 == (d & 240)) d = ((d & 15) << 12) | (g << 6) | h;
                            else {
                                var f = c[b++] & 63;
                                if (240 == (d & 248)) d = ((d & 7) << 18) | (g << 12) | (h << 6) | f;
                                else {
                                    var k = c[b++] & 63;
                                    if (248 == (d & 252)) d = ((d & 3) << 24) | (g << 18) | (h << 12) | (f << 6) | k;
                                    else {
                                        var H = c[b++] & 63;
                                        d = ((d & 1) << 30) | (g << 24) | (h << 18) | (f << 12) | (k << 6) | H;
                                    }
                                }
                            }
                            65536 > d ? (e += String.fromCharCode(d)) : ((d -= 65536), (e += String.fromCharCode(55296 | (d >> 10), 56320 | (d & 1023))));
                        }
                    else e += String.fromCharCode(d);
                }
        }
        return b;
    }
    var J = "undefined" !== typeof TextDecoder ? new TextDecoder("utf8") : void 0;
    "undefined" !== typeof TextDecoder && new TextDecoder("utf-16le");
    var buffer, F, G, K;
    function da() {
        a.HEAP8 = F = new Int8Array(buffer);
        a.HEAP16 = new Int16Array(buffer);
        a.HEAP32 = K = new Int32Array(buffer);
        a.HEAPU8 = G = new Uint8Array(buffer);
        a.HEAPU16 = new Uint16Array(buffer);
        a.HEAPU32 = new Uint32Array(buffer);
        a.HEAPF32 = new Float32Array(buffer);
        a.HEAPF64 = new Float64Array(buffer);
    }
    var L, M, N, O, P, Q, R;
    L = M = N = O = P = Q = R = 0;
    function ea() {
        x(
            "Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value " +
            S +
            ", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime, or (3) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 "
        );
    }
    var T = a.TOTAL_STACK || 5242880,
        S = a.TOTAL_MEMORY || 16777216;
    S < T && z("TOTAL_MEMORY should be larger than TOTAL_STACK, was " + S + "! (TOTAL_STACK=" + T + ")");
    a.buffer
        ? (buffer = a.buffer)
        : ("object" === typeof WebAssembly && "function" === typeof WebAssembly.Memory ? ((a.wasmMemory = new WebAssembly.Memory({ initial: S / 65536, maximum: S / 65536 })), (buffer = a.wasmMemory.buffer)) : (buffer = new ArrayBuffer(S)),
            (a.buffer = buffer));
    da();
    function U(b) {
        for (; 0 < b.length;) {
            var c = b.shift();
            if ("function" == typeof c) c();
            else {
                var e = c.f;
                "number" === typeof e ? (void 0 === c.a ? a.dynCall_v(e) : a.dynCall_vi(e, c.a)) : e(void 0 === c.a ? null : c.a);
            }
        }
    }
    var fa = [],
        ha = [],
        ia = [],
        ja = [],
        ka = !1;
    function la() {
        var b = a.preRun.shift();
        fa.unshift(b);
    }
    var V = 0,
        W = null,
        X = null;
    a.preloadedImages = {};
    a.preloadedAudios = {};
    function Y(b) {
        return String.prototype.startsWith ? b.startsWith("data:application/octet-stream;base64,") : 0 === b.indexOf("data:application/octet-stream;base64,");
    }
    (function () {
        function b() {
            try {
                if (a.wasmBinary) return new Uint8Array(a.wasmBinary);
                if (a.readBinary) return a.readBinary(g);
                throw "both async and sync fetching of the wasm failed";
            } catch (oa) {
                x(oa);
            }
        }
        function c() {
            return a.wasmBinary || (!n && !p) || "function" !== typeof fetch
                ? new Promise(function (c) {
                    c(b());
                })
                : fetch(g, { credentials: "same-origin" })
                    .then(function (b) {
                        if (!b.ok) throw "failed to load wasm binary file at '" + g + "'";
                        return b.arrayBuffer();
                    })
                    .catch(function () {
                        return b();
                    });
        }
        function e(b) {
            function d(b) {
                k = b.exports;
                if (k.memory) {
                    b = k.memory;
                    var c = a.buffer;
                    b.byteLength < c.byteLength && z("the new buffer in mergeMemory is smaller than the previous one. in native wasm, we should grow memory here");
                    c = new Int8Array(c);
                    new Int8Array(b).set(c);
                    a.buffer = buffer = b;
                    da();
                }
                a.asm = k;
                a.usingWasm = !0;
                V--;
                a.monitorRunDependencies && a.monitorRunDependencies(V);
                0 == V && (null !== W && (clearInterval(W), (W = null)), X && ((b = X), (X = null), b()));
            }
            function e(b) {
                d(b.instance);
            }
            function h(b) {
                c()
                    .then(function (b) {
                        return WebAssembly.instantiate(b, f);
                    })
                    .then(b, function (b) {
                        z("failed to asynchronously prepare wasm: " + b);
                        x(b);
                    });
            }
            if ("object" !== typeof WebAssembly) return z("no native wasm support detected"), !1;
            if (!(a.wasmMemory instanceof WebAssembly.Memory)) return z("no native wasm Memory in use"), !1;
            b.memory = a.wasmMemory;
            f.global = { NaN: NaN, Infinity: Infinity };
            f["global.Math"] = Math;
            f.env = b;
            V++;
            a.monitorRunDependencies && a.monitorRunDependencies(V);
            if (a.instantiateWasm)
                try {
                    return a.instantiateWasm(f, d);
                } catch (pa) {
                    return z("Module.instantiateWasm callback failed with error: " + pa), !1;
                }
            a.wasmBinary || "function" !== typeof WebAssembly.instantiateStreaming || Y(g) || "function" !== typeof fetch
                ? h(e)
                : WebAssembly.instantiateStreaming(fetch(g, { credentials: "same-origin" }), f).then(e, function (b) {
                    z("wasm streaming compile failed: " + b);
                    z("falling back to ArrayBuffer instantiation");
                    h(e);
                });
            return {};
        }
        var d = "tinyrsid.wast",
            g = "tinyrsid.wasm",
            h = "tinyrsid.temp.asm.js";
        Y(d) || (d = u(d));
        Y(g) || (g = u(g));
        Y(h) || (h = u(h));
        var f = { global: null, env: null, asm2wasm: aa, parent: a },
            k = null;
        a.asmPreload = a.asm;
        var H = a.reallocBuffer;
        a.reallocBuffer = function (b) {
            if ("asmjs" === qa) var c = H(b);
            else
                a: {
                    var d = a.usingWasm ? 65536 : 16777216;
                    0 < b % d && (b += d - (b % d));
                    d = a.buffer.byteLength;
                    if (a.usingWasm)
                        try {
                            c = -1 !== a.wasmMemory.grow((b - d) / 65536) ? (a.buffer = a.wasmMemory.buffer) : null;
                            break a;
                        } catch (va) {
                            c = null;
                            break a;
                        }
                    c = void 0;
                }
            return c;
        };
        var qa = "";
        a.asm = function (b, c) {
            if (!c.table) {
                b = a.wasmTableSize;
                void 0 === b && (b = 1024);
                var d = a.wasmMaxTableSize;
                c.table =
                    "object" === typeof WebAssembly && "function" === typeof WebAssembly.Table
                        ? void 0 !== d
                            ? new WebAssembly.Table({ initial: b, maximum: d, element: "anyfunc" })
                            : new WebAssembly.Table({ initial: b, element: "anyfunc" })
                        : Array(b);
                a.wasmTable = c.table;
            }
            c.memoryBase || (c.memoryBase = a.STATIC_BASE);
            c.tableBase || (c.tableBase = 0);
            c = e(c);
            assert(c, "no binaryen method succeeded.");
            return c;
        };
    })();
    var ma = [
        function () {
            console.log("FATAL ERROR: no free memory for driver");
        },
        function (b) {
            /* console.log("BRK from:        $"+b.toString(16))*/
        },
        function () {
            console.log("ERROR: PSID INIT hangs");
        },
        function () {
            console.log("info cannot be retrieved  from corrupt .mus file");
        },
    ];
    L = 1024;
    M = L + 297232;
    ha.push({
        f: function () {
            na();
        },
    });
    a.STATIC_BASE = L;
    a.STATIC_BUMP = 297232;
    M += 16;
    function ra(b) {
        return Math.pow(2, b);
    }
    var sa = M;
    M = (M + 4 + 15) & -16;
    R = sa;
    N = O = A(M);
    P = N + T;
    Q = A(P);
    K[R >> 2] = Q;
    a.wasmTableSize = 1;
    a.wasmMaxTableSize = 1;
    a.b = {};
    a.c = {
        abort: x,
        enlargeMemory: function () {
            ea();
        },
        getTotalMemory: function () {
            return S;
        },
        abortOnCannotGrowMemory: ea,
        ___setErrNo: function (b) {
            a.___errno_location && (K[a.___errno_location() >> 2] = b);
            return b;
        },
        _emscripten_asm_const_i: function (b) {
            return ma[b]();
        },
        _emscripten_asm_const_ii: function (b, c) {
            return ma[b](c);
        },
        _emscripten_memcpy_big: function (b, c, e) {
            G.set(G.subarray(c, c + e), b);
            return b;
        },
        _llvm_exp2_f64: function () {
            return ra.apply(null, arguments);
        },
        DYNAMICTOP_PTR: R,
        STACKTOP: O,
    };
    var ta = a.asm(a.b, a.c, buffer);
    a.asm = ta;
    var na = (a.__GLOBAL__sub_I_sid_cpp = function () {
        return a.asm.__GLOBAL__sub_I_sid_cpp.apply(null, arguments);
    });
    a._computeAudioSamples = function () {
        return a.asm._computeAudioSamples.apply(null, arguments);
    };
    a._enableVoice = function () {
        return a.asm._enableVoice.apply(null, arguments);
    };
    a._enableVoices = function () {
        return a.asm._enableVoices.apply(null, arguments);
    };
    a._envIsNTSC = function () {
        return a.asm._envIsNTSC.apply(null, arguments);
    };
    a._envIsSID6581 = function () {
        return a.asm._envIsSID6581.apply(null, arguments);
    };
    a._envSetNTSC = function () {
        return a.asm._envSetNTSC.apply(null, arguments);
    };
    a._envSetSID6581 = function () {
        return a.asm._envSetSID6581.apply(null, arguments);
    };
    a._envSidVersion = function () {
        return a.asm._envSidVersion.apply(null, arguments);
    };
    a._free = function () {
        return a.asm._free.apply(null, arguments);
    };
    a._getBufferVoice1 = function () {
        return a.asm._getBufferVoice1.apply(null, arguments);
    };
    a._getBufferVoice2 = function () {
        return a.asm._getBufferVoice2.apply(null, arguments);
    };
    a._getBufferVoice3 = function () {
        return a.asm._getBufferVoice3.apply(null, arguments);
    };
    a._getBufferVoice4 = function () {
        return a.asm._getBufferVoice4.apply(null, arguments);
    };
    a._getDigiRate = function () {
        return a.asm._getDigiRate.apply(null, arguments);
    };
    a._getDigiType = function () {
        return a.asm._getDigiType.apply(null, arguments);
    };
    a._getDigiTypeDesc = function () {
        return a.asm._getDigiTypeDesc.apply(null, arguments);
    };
    a._getGlobalDigiRate = function () {
        return a.asm._getGlobalDigiRate.apply(null, arguments);
    };
    a._getGlobalDigiType = function () {
        return a.asm._getGlobalDigiType.apply(null, arguments);
    };
    a._getGlobalDigiTypeDesc = function () {
        return a.asm._getGlobalDigiTypeDesc.apply(null, arguments);
    };
    a._getMusicInfo = function () {
        return a.asm._getMusicInfo.apply(null, arguments);
    };
    a._getNumberTraceStreams = function () {
        return a.asm._getNumberTraceStreams.apply(null, arguments);
    };
    a._getRAM = function () {
        return a.asm._getRAM.apply(null, arguments);
    };
    a._getRegisterSID = function () {
        return a.asm._getRegisterSID.apply(null, arguments);
    };
    a._getSampleRate = function () {
        return a.asm._getSampleRate.apply(null, arguments);
    };
    a._getSoundBuffer = function () {
        return a.asm._getSoundBuffer.apply(null, arguments);
    };
    a._getSoundBufferLen = function () {
        return a.asm._getSoundBufferLen.apply(null, arguments);
    };
    a._getTraceStreams = function () {
        return a.asm._getTraceStreams.apply(null, arguments);
    };
    a._loadSidFile = function () {
        return a.asm._loadSidFile.apply(null, arguments);
    };
    a._malloc = function () {
        return a.asm._malloc.apply(null, arguments);
    };
    a._playTune = function () {
        return a.asm._playTune.apply(null, arguments);
    };
    var E = (a.stackAlloc = function () {
        return a.asm.stackAlloc.apply(null, arguments);
    }),
        D = (a.stackRestore = function () {
            return a.asm.stackRestore.apply(null, arguments);
        }),
        C = (a.stackSave = function () {
            return a.asm.stackSave.apply(null, arguments);
        });
    a.dynCall_v = function () {
        return a.asm.dynCall_v.apply(null, arguments);
    };
    a.asm = ta;
    a.ccall = function (b, c, e, d) {
        var g = a["_" + b];
        assert(g, "Cannot call unknown function " + b + ", make sure it is exported");
        var h = [];
        b = 0;
        if (d)
            for (var f = 0; f < d.length; f++) {
                var k = ba[e[f]];
                k ? (0 === b && (b = C()), (h[f] = k(d[f]))) : (h[f] = d[f]);
            }
        e = g.apply(null, h);
        e = "string" === c ? ca(e) : "boolean" === c ? !!e : e;
        0 !== b && D(b);
        return e;
    };
    X = function ua() {
        a.calledRun || Z();
        a.calledRun || (X = ua);
    };
    function Z() {
        function b() {
            if (!a.calledRun && ((a.calledRun = !0), !B)) {
                ka || ((ka = !0), U(ha));
                U(ia);
                if (a.onRuntimeInitialized) a.onRuntimeInitialized();
                if (a.postRun)
                    for ("function" == typeof a.postRun && (a.postRun = [a.postRun]); a.postRun.length;) {
                        var b = a.postRun.shift();
                        ja.unshift(b);
                    }
                U(ja);
            }
        }
        if (!(0 < V)) {
            if (a.preRun) for ("function" == typeof a.preRun && (a.preRun = [a.preRun]); a.preRun.length;) la();
            U(fa);
            0 < V ||
                a.calledRun ||
                (a.setStatus
                    ? (a.setStatus("Running..."),
                        setTimeout(function () {
                            setTimeout(function () {
                                a.setStatus("");
                            }, 1);
                            b();
                        }, 1))
                    : b());
        }
    }
    a.run = Z;
    function x(b) {
        if (a.onAbort) a.onAbort(b);
        void 0 !== b ? (y(b), z(b), (b = JSON.stringify(b))) : (b = "");
        B = !0;
        throw "abort(" + b + "). Build with -s ASSERTIONS=1 for more info.";
    }
    a.abort = x;
    if (a.preInit) for ("function" == typeof a.preInit && (a.preInit = [a.preInit]); 0 < a.preInit.length;) a.preInit.pop()();
    a.noExitRuntime = !0;
    Z();
    return {
        Module: Module, // expose original Module
    };
})(window.spp_backend_state_SID);
/*
 tinyrsid_adapter.js: Adapts Tiny'R'Sid backend to generic WebAudio/ScriptProcessor player.
 
 version 1.01
 
 	Copyright (C) 2018 Juergen Wothke

 LICENSE
 
 This software is licensed under a CC BY-NC-SA 
 (http://creativecommons.org/licenses/by-nc-sa/4.0/).
*/
SIDBackendAdapter = (function () {
    var $this = function () {
        $this.base.call(this, backend_SID.Module, 2); // use stereo (for the benefit of multi-SID songs)
        this.playerSampleRate;

        this._scopeEnabled = false;
    };
    // TinyRSid's sample buffer contains 2-byte (signed short) sample data
    // for 1 channel
    extend(EmsHEAP16BackendAdapter, $this, {
        enableScope: function (enable) {
            this._scopeEnabled = enable;
        },
        getAudioBuffer: function () {
            var ptr = this.Module.ccall("getSoundBuffer", "number");
            return ptr >> 1; // 16 bit samples
        },
        getAudioBufferLength: function () {
            var len = this.Module.ccall("getSoundBufferLen", "number");
            return len;
        },
        printMemDump: function (name, startAddr, endAddr) {
            // util for debugging
            var text = "const unsigned char " + name + "[] =\n{\n";
            var line = "";
            var j = 0;
            for (var i = 0; i < endAddr - startAddr + 1; i++) {
                var d = this.Module.ccall("getRAM", "number", ["number"], [startAddr + i]);
                line += "0x" + ("00" + d.toString(16)).substr(-2).toUpperCase() + ", ";
                if (j == 11) {
                    text += line + "\n";
                    line = "";
                    j = 0;
                } else {
                    j++;
                }
            }
            text += (j ? line + "\n" : "") + "}\n";
            console.log(text);
        },
        computeAudioSamples: function () {
            var len = this.Module.ccall("computeAudioSamples", "number");
            if (len <= 0) {
                return 1; // >0 means "end song"
            }
            return 0;
        },
        getPathAndFilename: function (filename) {
            return ["/", filename];
        },
        registerFileData: function (pathFilenameArray, data) {
            return 0; // FS not used in Tiny'R'Sid
        },
        loadMusicData: function (sampleRate, path, filename, data, options) {
            var buf = this.Module._malloc(data.length);
            this.Module.HEAPU8.set(data, buf);

            // try to use native sample rate to avoid resampling
            this.playerSampleRate = typeof window._gPlayerAudioCtx == "undefined" ? 0 : window._gPlayerAudioCtx.sampleRate;

            var isMus = filename.endsWith(".mus") || filename.endsWith(".str"); // Compute! Sidplayer file (stereo files not supported)
            var ret = this.Module.ccall("loadSidFile", "number", ["number", "number", "number", "number", "string"], [isMus, buf, data.length, this.playerSampleRate, filename]);
            this.Module._free(buf);

            if (ret == 0) {
                this.playerSampleRate = this.Module.ccall("getSampleRate", "number");
                this.resetSampleRate(sampleRate, this.playerSampleRate);
            }
            return ret;
        },
        evalTrackOptions: function (options) {
            if (typeof options.timeout != "undefined") {
                ScriptNodePlayer.getInstance().setPlaybackTimeout(options.timeout * 1000);
            }
            var traceSID = this._scopeEnabled;
            if (typeof options.traceSID != "undefined") {
                traceSID = options.traceSID;
            }
            if (typeof options.track == "undefined") {
                options.track = -1;
            }
            return this.Module.ccall("playTune", "number", ["number", "number"], [options.track, traceSID]);
        },
        teardown: function () {
            // nothing to do
        },
        getSongInfoMeta: function () {
            return {
                loadAddr: Number,
                playSpeed: Number,
                maxSubsong: Number,
                actualSubsong: Number,
                songName: String,
                songAuthor: String,
                songReleased: String,
            };
        },
        getExtAsciiString: function (heapPtr) {
            // Pointer_stringify cannot be used here since UTF-8 parsing
            // messes up original extASCII content
            var text = "";
            for (var j = 0; j < 32; j++) {
                var b = this.Module.HEAP8[heapPtr + j] & 0xff;
                if (b == 0) break;

                if (b < 128) {
                    text = text + String.fromCharCode(b);
                } else {
                    text = text + "&#" + b + ";";
                }
            }
            return text;
        },
        updateSongInfo: function (filename, result) {
            // get song infos (so far only use some top level module infos)
            var numAttr = 7;
            var ret = this.Module.ccall("getMusicInfo", "number");

            var array = this.Module.HEAP32.subarray(ret >> 2, (ret >> 2) + 7);
            result.loadAddr = this.Module.HEAP32[array[0] >> 2]; // i32
            result.playSpeed = this.Module.HEAP32[array[1] >> 2]; // i32
            result.maxSubsong = this.Module.HEAP8[array[2]]; // i8
            result.actualSubsong = this.Module.HEAP8[array[3]]; // i8
            result.songName = this.getExtAsciiString(array[4]);
            result.songAuthor = this.getExtAsciiString(array[5]);
            result.songReleased = this.getExtAsciiString(array[6]);
        },

        // C64 emu specific accessors (that might be useful in GUI)
        isSID6581: function () {
            return this.Module.ccall("envIsSID6581", "number");
        },
        setSID6581: function (is6581) {
            this.Module.ccall("envSetSID6581", "number", ["number"], [is6581]);
        },
        isNTSC: function () {
            return this.Module.ccall("envIsNTSC", "number");
        },
        setNTSC: function (ntsc) {
            this.Module.ccall("envSetNTSC", "number", ["number"], [ntsc]);
        },

        // To activate the below output a song must be started with the "traceSID" option set to 1:
        // At any given moment the below getters will then correspond to the output of getAudioBuffer
        // and what has last been generated by computeAudioSamples. They expose some of the respective
        // underlying internal SID state (the "filter" is NOT reflected in this data).
        getNumberTraceStreams: function () {
            return this.Module.ccall("getNumberTraceStreams", "number");
        },
        getTraceStreams: function () {
            var result = [];
            var n = this.getNumberTraceStreams();

            var ret = this.Module.ccall("getTraceStreams", "number");
            var array = this.Module.HEAP32.subarray(ret >> 2, (ret >> 2) + n);

            for (var i = 0; i < n; i++) {
                result.push(array[i] >> 1); // pointer to int16 array
            }
            return result;
        },

        readFloatTrace: function (buffer, idx) {
            return this.Module.HEAP16[buffer + idx] / 0x8000;
        },
        // perf optimization:
        getCopiedScopeStream: function (input, len, output) {
            for (var i = 0; i < len; i++) {
                output[i] = this.Module.HEAP16[input + i]; // will be scaled later anyway.. avoid the extra division here /0x8000;
            }
            return len;
        },

        /**
         * This just queries the *current* state of the emulator. It
         * is less precisely correlated to the music that is currently playing (than the above
         * buffers), i.e. it represents the state *after* the last emulator call (respective data
         * may not yet have been fed to WebAudio or if it has already been fed then
         * WebAudio may not yet be playing it yet). The lag should normally not be very large
         * (<0.2s) and when using it for display purposes it would be hard to see a difference anyway.
         */
        getRegisterSID: function (offset) {
            return this.Module.ccall("getRegisterSID", "number", ["number"], [offset]);
        },
        getRAM: function (offset) {
            return this.Module.ccall("getRAM", "number", ["number"], [offset]);
        },
        /**
         * Diagnostics digi-samples (if any).
         */
        getDigiType: function () {
            return this.Module.ccall("getDigiType", "number");
        },
        getDigiTypeDesc: function () {
            return this.getExtAsciiString(this.Module.ccall("getDigiTypeDesc", "number"));
        },
        getDigiRate: function () {
            return this.Module.ccall("getDigiRate", "number");
        },
        enableVoice: function (sidIdx, voice, on) {
            this.Module.ccall("enableVoice", "number", ["number", "number", "number"], [sidIdx, voice, on]);
        },

        /*
         * @deprecated APIs below - use getTraceStreams/getNumberTraceStreams instead
         */
        // disable voices (0-3) by clearing respective bit
        enableVoices: function (mask) {
            this.Module.ccall("enableVoices", "number", ["number"], [mask]);
        },
        getBufferVoice1: function () {
            var ptr = this.Module.ccall("getBufferVoice1", "number");
            return ptr >> 1; // 16 bit samples
        },
        getBufferVoice2: function () {
            var ptr = this.Module.ccall("getBufferVoice2", "number");
            return ptr >> 1; // 16 bit samples
        },
        getBufferVoice3: function () {
            var ptr = this.Module.ccall("getBufferVoice3", "number");
            return ptr >> 1; // 16 bit samples
        },
        getBufferVoice4: function () {
            var ptr = this.Module.ccall("getBufferVoice4", "number");
            return ptr >> 1; // 16 bit samples
        },
    });
    return $this;
})();

